package com.haomostudio.so.controller;

import com.haomostudio.so.common.Resp;
import com.haomostudio.so.po.TClient;
import com.haomostudio.so.service.TClientService;
import com.haomostudio.so.service.HmUtils.Tools;
import com.alibaba.fastjson.*;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.lang.reflect.InvocationTargetException;
import java.text.SimpleDateFormat;
import java.util.*;

/**
 * Created by hxg on 2016/10/06.
 */
@Api(description = "TClient")
@Controller
public class TClientController {

    @Autowired
    TClientService tClientService;

    @Autowired
    HttpServletResponse response;

    @ApiOperation(value = "创建'TClient'表中一条信息", notes = "通过post方法请求，传入表中字段的对应信息，创建一条数据。并返回给View层")
    @RequestMapping(value = "/t_clients/new",
                    method = RequestMethod.POST,
                    produces = "application/json;charset=UTF-8")
    @ResponseBody
    public Object createTClient(
            HttpServletRequest request,
            @RequestHeader(value = "X-Auth-Token") String token,
            @RequestParam(value = "name", required = false) String name,
            @RequestParam(value = "contact", required = false) String contact,
            @RequestParam(value = "phone", required = false) String phone,
            @RequestParam(value = "email", required = false) String email,
            @RequestParam(value = "address", required = false) String address,
            @RequestParam(value = "weixin", required = false) String weixin,
            @RequestParam(value = "remark", required = false) String remark,
            @RequestParam(value = "saleManager", required = false) String saleManager,
            @RequestParam(value = "registerWay", required = false) Integer registerWay,
            @RequestParam(value = "adminUserId", required = false) Integer adminUserId,
            @RequestParam(value = "productId", required = false) Integer productId,
            @RequestParam(value = "productStartDate", required = false) String productStartDate,
            @RequestParam(value = "productEndDate", required = false) String productEndDate,
            @RequestParam(value = "productStatus", required = false) Integer productStatus,
            @RequestParam(value = "isForver", required = false) Integer isForver,
            @RequestParam(value = "spaceId", required = false) Integer spaceId,
            @RequestParam(value = "spaceWeixinId", required = false) Integer spaceWeixinId,
            @RequestParam(value = "spaceWeixinPayId", required = false) Integer spaceWeixinPayId,
            @RequestParam(value = "spaceWeixinPayStatus", required = false) Integer spaceWeixinPayStatus,
            @RequestParam(value = "createDate", required = false) String createDate,
            @RequestParam(value = "modifieDate", required = false) String modifieDate
    ) {
        TClient item = new TClient();
        String id = Tools.getUUID();
        item.setId(Integer.valueOf(id));
        if( name != null ){
            item.setName(name);
        }
        if( contact != null ){
            item.setContact(contact);
        }
        if( phone != null ){
            item.setPhone(phone);
        }
        if( email != null ){
            item.setEmail(email);
        }
        if( address != null ){
            item.setAddress(address);
        }
        if( weixin != null ){
            item.setWeixin(weixin);
        }
        if( remark != null ){
            item.setRemark(remark);
        }
        if( saleManager != null ){
            item.setSaleManager(saleManager);
        }
        if( registerWay != null ){
            item.setRegisterWay(registerWay);
        }
        if( adminUserId != null ){
            item.setAdminUserId(adminUserId);
        }
        if( productId != null ){
            item.setProductId(productId);
        }
        if( productStartDate != null ){
            item.setProductStartDate(Tools.convertStringToDate(productStartDate, "yyyy-MM-dd HH:mm:ss"));
        }
        if( productEndDate != null ){
            item.setProductEndDate(Tools.convertStringToDate(productEndDate, "yyyy-MM-dd HH:mm:ss"));
        }
        if( productStatus != null ){
            item.setProductStatus(productStatus);
        }
        if( isForver != null ){
            item.setIsForver(isForver);
        }
        if( spaceId != null ){
            item.setSpaceId(spaceId);
        }
        if( spaceWeixinId != null ){
            item.setSpaceWeixinId(spaceWeixinId);
        }
        if( spaceWeixinPayId != null ){
            item.setSpaceWeixinPayId(spaceWeixinPayId);
        }
        if( spaceWeixinPayStatus != null ){
            item.setSpaceWeixinPayStatus(spaceWeixinPayStatus);
        }
        if( createDate != null ){
            item.setCreateDate(Tools.convertStringToDate(createDate, "yyyy-MM-dd HH:mm:ss"));
        }
        if( modifieDate != null ){
            item.setModifieDate(Tools.convertStringToDate(modifieDate, "yyyy-MM-dd HH:mm:ss"));
        }
        tClientService.create(item);

        //若request param为null，但字段定义有默认值，则需从数据库中返回结果
        return tClientService.get(Integer.valueOf(id));
        //return item;
    }

    @ApiOperation(value = "删除'TClient'表中的某条记录", notes = "根据url传入的数据id，删除整条记录。")
    @RequestMapping(value = "/t_clients/{t_client_id}/delete",
                    method = RequestMethod.POST,
                    produces = "application/json;charset=UTF-8")
    @ResponseBody
    public Object deleteTClient(
            @RequestHeader(value = "X-Auth-Token") String token,
            @PathVariable(value = "t_client_id") Integer id
    ) {
        TClient item = tClientService.get(id);
        if (null == item) {
            response.setStatus(404);
            return Resp.fail("the asset to be deleted doesn't exist");
        }

        tClientService.delete(id);
        return Resp.succ("delete success");
    }

    @ApiOperation(value = "修改'TClient'表中的某条记录", notes = "根据url传入的数据id，确定修改表中的某条记录，传入表中字段要修改的信息，不传代表不修改。并返回给View层")
    @RequestMapping(value = "/t_clients/{t_client_id}/edit",
                    method = RequestMethod.POST,
                    produces = "application/json;charset=UTF-8")
    @ResponseBody
    public Object editTClient(
            HttpServletRequest request,
            @RequestHeader(value = "X-Auth-Token") String token,
            @PathVariable(value = "t_client_id") Integer id,
            @RequestParam(value = "name", required = false) String name,
            @RequestParam(value = "contact", required = false) String contact,
            @RequestParam(value = "phone", required = false) String phone,
            @RequestParam(value = "email", required = false) String email,
            @RequestParam(value = "address", required = false) String address,
            @RequestParam(value = "weixin", required = false) String weixin,
            @RequestParam(value = "remark", required = false) String remark,
            @RequestParam(value = "saleManager", required = false) String saleManager,
            @RequestParam(value = "registerWay", required = false) Integer registerWay,
            @RequestParam(value = "adminUserId", required = false) Integer adminUserId,
            @RequestParam(value = "productId", required = false) Integer productId,
            @RequestParam(value = "productStartDate", required = false) String productStartDate,
            @RequestParam(value = "productEndDate", required = false) String productEndDate,
            @RequestParam(value = "productStatus", required = false) Integer productStatus,
            @RequestParam(value = "isForver", required = false) Integer isForver,
            @RequestParam(value = "spaceId", required = false) Integer spaceId,
            @RequestParam(value = "spaceWeixinId", required = false) Integer spaceWeixinId,
            @RequestParam(value = "spaceWeixinPayId", required = false) Integer spaceWeixinPayId,
            @RequestParam(value = "spaceWeixinPayStatus", required = false) Integer spaceWeixinPayStatus,
            @RequestParam(value = "createDate", required = false) String createDate,
            @RequestParam(value = "modifieDate", required = false) String modifieDate
    ) {
        TClient item = tClientService.get(id);
        if (null == item) {
            response.setStatus(404);
            return Resp.fail("the asset to be edited doesn't exist");
        }

        if( name != null ){
            item.setName(name);
        }
        if( contact != null ){
            item.setContact(contact);
        }
        if( phone != null ){
            item.setPhone(phone);
        }
        if( email != null ){
            item.setEmail(email);
        }
        if( address != null ){
            item.setAddress(address);
        }
        if( weixin != null ){
            item.setWeixin(weixin);
        }
        if( remark != null ){
            item.setRemark(remark);
        }
        if( saleManager != null ){
            item.setSaleManager(saleManager);
        }
        if( registerWay != null ){
            item.setRegisterWay(registerWay);
        }
        if( adminUserId != null ){
            item.setAdminUserId(adminUserId);
        }
        if( productId != null ){
            item.setProductId(productId);
        }
        if( productStartDate != null ){
            item.setProductStartDate(Tools.convertStringToDate(productStartDate, "yyyy-MM-dd HH:mm:ss"));
        }
        if( productEndDate != null ){
            item.setProductEndDate(Tools.convertStringToDate(productEndDate, "yyyy-MM-dd HH:mm:ss"));
        }
        if( productStatus != null ){
            item.setProductStatus(productStatus);
        }
        if( isForver != null ){
            item.setIsForver(isForver);
        }
        if( spaceId != null ){
            item.setSpaceId(spaceId);
        }
        if( spaceWeixinId != null ){
            item.setSpaceWeixinId(spaceWeixinId);
        }
        if( spaceWeixinPayId != null ){
            item.setSpaceWeixinPayId(spaceWeixinPayId);
        }
        if( spaceWeixinPayStatus != null ){
            item.setSpaceWeixinPayStatus(spaceWeixinPayStatus);
        }
        if( createDate != null ){
            item.setCreateDate(Tools.convertStringToDate(createDate, "yyyy-MM-dd HH:mm:ss"));
        }
        if( modifieDate != null ){
            item.setModifieDate(Tools.convertStringToDate(modifieDate, "yyyy-MM-dd HH:mm:ss"));
        }
        tClientService.update(item);

        return tClientService.get(id);
    }

    @ApiOperation(value = "查询'TClient'表中的某条记录", notes = "根据url传入的数据id，查询对应的一条数据。")
    @RequestMapping(value = "/t_clients/{t_client_id}",
                    method = {RequestMethod.GET, RequestMethod.DELETE, RequestMethod.PUT},
                    produces = "application/json;charset=UTF-8")
    @ResponseBody
    public Object getTClient(
            HttpServletRequest request,
            @RequestHeader(value = "X-Auth-Token") String token,
            @PathVariable(value = "t_client_id") Integer id,
            @RequestParam(value = "name", required = false) String name,
            @RequestParam(value = "contact", required = false) String contact,
            @RequestParam(value = "phone", required = false) String phone,
            @RequestParam(value = "email", required = false) String email,
            @RequestParam(value = "address", required = false) String address,
            @RequestParam(value = "weixin", required = false) String weixin,
            @RequestParam(value = "remark", required = false) String remark,
            @RequestParam(value = "saleManager", required = false) String saleManager,
            @RequestParam(value = "registerWay", required = false) Integer registerWay,
            @RequestParam(value = "adminUserId", required = false) Integer adminUserId,
            @RequestParam(value = "productId", required = false) Integer productId,
            @RequestParam(value = "productStartDate", required = false) String productStartDate,
            @RequestParam(value = "productEndDate", required = false) String productEndDate,
            @RequestParam(value = "productStatus", required = false) Integer productStatus,
            @RequestParam(value = "isForver", required = false) Integer isForver,
            @RequestParam(value = "spaceId", required = false) Integer spaceId,
            @RequestParam(value = "spaceWeixinId", required = false) Integer spaceWeixinId,
            @RequestParam(value = "spaceWeixinPayId", required = false) Integer spaceWeixinPayId,
            @RequestParam(value = "spaceWeixinPayStatus", required = false) Integer spaceWeixinPayStatus,
            @RequestParam(value = "createDate", required = false) String createDate,
            @RequestParam(value = "modifieDate", required = false) String modifieDate
    ) {
        if(request.getMethod().equals("GET")){
            TClient item = tClientService.get(id);
            if (null == item) {
                response.setStatus(404);
                return Resp.fail("the asset to be edited doesn't exist");
            }

            return item;
        }
        else if(request.getMethod().equals("PUT")){
            TClient item = tClientService.get(id);
            if (null == item) {
                response.setStatus(404);
                return Resp.fail("the asset to be edited doesn't exist");
            }

            if( name != null ){
                item.setName(name);
            }
            if( contact != null ){
                item.setContact(contact);
            }
            if( phone != null ){
                item.setPhone(phone);
            }
            if( email != null ){
                item.setEmail(email);
            }
            if( address != null ){
                item.setAddress(address);
            }
            if( weixin != null ){
                item.setWeixin(weixin);
            }
            if( remark != null ){
                item.setRemark(remark);
            }
            if( saleManager != null ){
                item.setSaleManager(saleManager);
            }
            if( registerWay != null ){
                item.setRegisterWay(registerWay);
            }
            if( adminUserId != null ){
                item.setAdminUserId(adminUserId);
            }
            if( productId != null ){
                item.setProductId(productId);
            }
            if( productStartDate != null ){
                item.setProductStartDate(Tools.convertStringToDate(productStartDate, "yyyy-MM-dd HH:mm:ss"));
            }
            if( productEndDate != null ){
                item.setProductEndDate(Tools.convertStringToDate(productEndDate, "yyyy-MM-dd HH:mm:ss"));
            }
            if( productStatus != null ){
                item.setProductStatus(productStatus);
            }
            if( isForver != null ){
                item.setIsForver(isForver);
            }
            if( spaceId != null ){
                item.setSpaceId(spaceId);
            }
            if( spaceWeixinId != null ){
                item.setSpaceWeixinId(spaceWeixinId);
            }
            if( spaceWeixinPayId != null ){
                item.setSpaceWeixinPayId(spaceWeixinPayId);
            }
            if( spaceWeixinPayStatus != null ){
                item.setSpaceWeixinPayStatus(spaceWeixinPayStatus);
            }
            if( createDate != null ){
                item.setCreateDate(Tools.convertStringToDate(createDate, "yyyy-MM-dd HH:mm:ss"));
            }
            if( modifieDate != null ){
                item.setModifieDate(Tools.convertStringToDate(modifieDate, "yyyy-MM-dd HH:mm:ss"));
            }
            tClientService.update(item);

            return tClientService.get(id);
        }
        else if(request.getMethod().equals("DELETE")){
            TClient item = tClientService.get(id);
            if (null == item) {
                response.setStatus(404);
                return Resp.fail("the asset to be deleted doesn't exist");
            }

            tClientService.delete(id);
            return Resp.succ("delete success");
        }
        return Resp.fail("Unknown http method");
    }

    @ApiOperation(value = "查询'TClient'表中的多条记录或者新增某条记录", notes = "get传参：根据url传入的filters（过滤条件），查询对应的多条数据。数据数量取决于pageNo和pageSize；数据的先后顺序取决于sortItem，sortOrder；   post请求：新增某条记录，传入表字段对应的值")
    @RequestMapping(value = "/t_clients",
                    method = { RequestMethod.GET, RequestMethod.POST },
                    produces = "application/json;charset=UTF-8")
    @ResponseBody
    public Object getTClients(
            HttpServletRequest request,
            @RequestHeader(value = "X-Auth-Token", required = false) String token,
            @RequestParam(value = "pageNo", required = false) Integer pageNo,
            @RequestParam(value = "pageSize", required = false) Integer pageSize,
            @RequestParam(value = "sortItem", required = false) String sortItem,
            @RequestParam(value = "sortOrder", required = false) String sortOrder,
            @RequestParam(value = "filters", required = false) String filters,
            @RequestParam(value = "includes", required = false) String includes,
            @RequestParam(value = "refers", required = false) String refers,
            @RequestParam(value = "relates", required = false) String relates
    ) {
        if(pageNo == null){
            pageNo = 1;
        }
        if(pageSize == null){
            pageSize = 10;
        }
        if(sortItem == null){
            sortItem = "id";
        }
        if(sortOrder == null){
            sortOrder = "asc";
        }
        if(filters == null){
            filters = "{}";
        }

        Long total = tClientService.countListWithPagingAndFilter(filters);
        response.addHeader("total", String.valueOf(total));

        return tClientService.getListWithPagingAndFilter(
                        pageNo, pageSize, sortItem, sortOrder, filters, includes, refers, relates);

    }

    @ApiOperation(value = "出入字段数组返回对应字段数据", notes = "get传参：根据url传入的filters（过滤条件），查询对应的多条数据。只返回你传进来的字段对应的数据")
    @RequestMapping(value = "/t_clients/columns",
                    method = { RequestMethod.GET },
                    produces = "application/json;charset=UTF-8")
    @ResponseBody
    public Object getTClientsId(
            HttpServletRequest request,
            @RequestHeader(value = "X-Auth-Token", required = false) String token,
            @RequestParam(value = "filters", required = true) String filters,
            @RequestParam(value = "columns", required = true) String columns,
            @RequestParam(value = "sortOrder", required = false) String sortOrder,
            @RequestParam(value = "sortItem", required = false) String sortItem,
            @RequestParam(value = "pageNo", required = false) Integer pageNo,
            @RequestParam(value = "pageSize", required = false) Integer pageSize
    ) {
        if(pageNo == null){
            pageNo = 1;
        }
        if(pageSize == null){
            pageSize = 10;
        }
        if(sortOrder==null){
            sortOrder = "asc";
        }
        if(sortItem==null){
            sortItem = "id";
        }
        JSONArray jsonArray = JSON.parseArray(columns);
        List<Map<String,Object>> lists  = new ArrayList<>();
        List<TClient> list = tClientService.getListWithPagingAndFilter(
                pageNo, pageSize, sortItem, sortOrder, filters);

        //反射调取get方法
        Class clz = TClient.class;
        list.stream().forEach(lot->{
            Map<String,Object> map = new HashMap<>();
            for (Object j : jsonArray){
                String s = (String) j;
                s = s.replaceFirst(s.substring(0,1),s.substring(0,1).toUpperCase());
                try {
                    if (clz.getMethod("get"+s).invoke(lot) !=null){
                        map.put((String) j,clz.getMethod("get"+s).invoke(lot));
                    }
                } catch (NoSuchMethodException e) {
                    e.printStackTrace();
                } catch (InvocationTargetException e) {
                    e.printStackTrace();
                } catch (IllegalAccessException e) {
                    e.printStackTrace();
                }
            }
            lists.add(map);
        });

        return lists;
     }



    @ApiOperation(value = "批量创建'TClient'表中一条信息", notes = "通过post方法请求，传入表中字段的对应信息，创建一条数据。并返回给View层")
    @RequestMapping(value = "/t_clients/create//batch",
               method = RequestMethod.POST,
               produces = "application/json;charset=UTF-8")
    @ResponseBody
    public Object createsTClients(
             HttpServletRequest request,
             @RequestHeader(value = "X-Auth-Token", required = false) String token,
             @RequestParam(value = "params", required = false) String params
    ) {

             JSONArray jsonArray = JSON.parseArray(params);
             List<TClient> lists  = new ArrayList<>();

             jsonArray.stream().forEach((Object object) -> {

             JSONObject jsonObject = JSONObject.parseObject(object.toString());

             TClient item = new TClient();
             String id = Tools.getUUID();
                         item.setId(Integer.valueOf(id));
             if(jsonObject.containsKey("name")   ){
            item.setName(jsonObject.get("name").toString());
        }
        if(jsonObject.containsKey("contact")   ){
            item.setContact(jsonObject.get("contact").toString());
        }
        if(jsonObject.containsKey("phone")   ){
            item.setPhone(jsonObject.get("phone").toString());
        }
        if(jsonObject.containsKey("email")   ){
            item.setEmail(jsonObject.get("email").toString());
        }
        if(jsonObject.containsKey("address")   ){
            item.setAddress(jsonObject.get("address").toString());
        }
        if(jsonObject.containsKey("weixin")   ){
            item.setWeixin(jsonObject.get("weixin").toString());
        }
        if(jsonObject.containsKey("remark")   ){
            item.setRemark(jsonObject.get("remark").toString());
        }
        if(jsonObject.containsKey("saleManager")   ){
            item.setSaleManager(jsonObject.get("saleManager").toString());
        }
        if(jsonObject.containsKey("registerWay")   ){
            item.setRegisterWay(Integer.valueOf(jsonObject.get("registerWay").toString()));
        }
        if(jsonObject.containsKey("adminUserId")   ){
            item.setAdminUserId(Integer.valueOf(jsonObject.get("adminUserId").toString()));
        }
        if(jsonObject.containsKey("productId")   ){
            item.setProductId(Integer.valueOf(jsonObject.get("productId").toString()));
        }
        if(jsonObject.containsKey("productStartDate")   ){
            item.setProductStartDate(Tools.convertStringToDate(jsonObject.get("productStartDate").toString(), "yyyy-MM-dd HH:mm:ss"));
        }
        if(jsonObject.containsKey("productEndDate")   ){
            item.setProductEndDate(Tools.convertStringToDate(jsonObject.get("productEndDate").toString(), "yyyy-MM-dd HH:mm:ss"));
        }
        if(jsonObject.containsKey("productStatus")   ){
            item.setProductStatus(Integer.valueOf(jsonObject.get("productStatus").toString()));
        }
        if(jsonObject.containsKey("isForver")   ){
            item.setIsForver(Integer.valueOf(jsonObject.get("isForver").toString()));
        }
        if(jsonObject.containsKey("spaceId")   ){
            item.setSpaceId(Integer.valueOf(jsonObject.get("spaceId").toString()));
        }
        if(jsonObject.containsKey("spaceWeixinId")   ){
            item.setSpaceWeixinId(Integer.valueOf(jsonObject.get("spaceWeixinId").toString()));
        }
        if(jsonObject.containsKey("spaceWeixinPayId")   ){
            item.setSpaceWeixinPayId(Integer.valueOf(jsonObject.get("spaceWeixinPayId").toString()));
        }
        if(jsonObject.containsKey("spaceWeixinPayStatus")   ){
            item.setSpaceWeixinPayStatus(Integer.valueOf(jsonObject.get("spaceWeixinPayStatus").toString()));
        }
        if(jsonObject.containsKey("createDate")   ){
            item.setCreateDate(Tools.convertStringToDate(jsonObject.get("createDate").toString(), "yyyy-MM-dd HH:mm:ss"));
        }
        if(jsonObject.containsKey("modifieDate")   ){
            item.setModifieDate(Tools.convertStringToDate(jsonObject.get("modifieDate").toString(), "yyyy-MM-dd HH:mm:ss"));
        }
             tClientService.create(item);
             lists.add(tClientService.get(Integer.valueOf(id)));

             });
        return lists;
     }

    @ApiOperation(value = "批量删除'TClient'表中一条信息", notes = "通过post方法请求，传入表中字段的对应信息，创建一条数据。并返回给View层")
        @RequestMapping(value = "/t_clients/delete/batch",
                method = RequestMethod.POST,
                produces = "application/json;charset=UTF-8")
        @ResponseBody
        public Object deletesTClient(
                HttpServletRequest request,
                @RequestHeader(value = "X-Auth-Token", required = false) String token,
                @RequestParam(value = "ids", required = true) String ids
        ) {

            JSONArray jsonArray = JSON.parseArray(ids);
            jsonArray.stream().forEach(id->{

                 TClient item = tClientService.get(Integer.valueOf(id.toString()));
                if (null != item) {
                    tClientService.delete(Integer.valueOf(id.toString()));
                }

            });
            return Resp.succ("delete success");
        }
}
