package com.haomostudio.so.controller;

import com.haomostudio.so.common.Resp;
import com.haomostudio.so.po.TPlatformActivity;
import com.haomostudio.so.service.TPlatformActivityService;
import com.haomostudio.so.service.HmUtils.Tools;
import com.alibaba.fastjson.*;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.lang.reflect.InvocationTargetException;
import java.text.SimpleDateFormat;
import java.util.*;

/**
 * Created by hxg on 2016/10/06.
 */
@Api(description = "TPlatformActivity")
@Controller
public class TPlatformActivityController {

    @Autowired
    TPlatformActivityService tPlatformActivityService;

    @Autowired
    HttpServletResponse response;

    @ApiOperation(value = "创建'TPlatformActivity'表中一条信息", notes = "通过post方法请求，传入表中字段的对应信息，创建一条数据。并返回给View层")
    @RequestMapping(value = "/t_platform_activities/new",
                    method = RequestMethod.POST,
                    produces = "application/json;charset=UTF-8")
    @ResponseBody
    public Object createTPlatformActivity(
            HttpServletRequest request,
            @RequestHeader(value = "X-Auth-Token") String token,
            @RequestParam(value = "code", required = false) String code,
            @RequestParam(value = "name", required = false) String name,
            @RequestParam(value = "regulation", required = false) String regulation,
            @RequestParam(value = "type", required = false) Integer type,
            @RequestParam(value = "template", required = false) Integer template,
            @RequestParam(value = "startDate", required = false) String startDate,
            @RequestParam(value = "endDate", required = false) String endDate,
            @RequestParam(value = "bannerPath", required = false) String bannerPath,
            @RequestParam(value = "lotteryPlayer", required = false) Integer lotteryPlayer,
            @RequestParam(value = "winningMaxTime", required = false) Integer winningMaxTime,
            @RequestParam(value = "lotteryInitTime", required = false) Integer lotteryInitTime,
            @RequestParam(value = "lotteryExtraTime", required = false) Integer lotteryExtraTime,
            @RequestParam(value = "created", required = false) String created,
            @RequestParam(value = "updated", required = false) String updated,
            @RequestParam(value = "status", required = false) Integer status,
            @RequestParam(value = "isDelete", required = false) Integer isDelete,
            @RequestParam(value = "canEdit", required = false) Integer canEdit
    ) {
        TPlatformActivity item = new TPlatformActivity();
        String id = Tools.getUUID();
        item.setId(Integer.valueOf(id));
        if( code != null ){
            item.setCode(code);
        }
        if( name != null ){
            item.setName(name);
        }
        if( regulation != null ){
            item.setRegulation(regulation);
        }
        if( type != null ){
            item.setType(type);
        }
        if( template != null ){
            item.setTemplate(template);
        }
        if( startDate != null ){
            item.setStartDate(Tools.convertStringToDate(startDate, "yyyy-MM-dd HH:mm:ss"));
        }
        if( endDate != null ){
            item.setEndDate(Tools.convertStringToDate(endDate, "yyyy-MM-dd HH:mm:ss"));
        }
        if( bannerPath != null ){
            item.setBannerPath(bannerPath);
        }
        if( lotteryPlayer != null ){
            item.setLotteryPlayer(lotteryPlayer);
        }
        if( winningMaxTime != null ){
            item.setWinningMaxTime(winningMaxTime);
        }
        if( lotteryInitTime != null ){
            item.setLotteryInitTime(lotteryInitTime);
        }
        if( lotteryExtraTime != null ){
            item.setLotteryExtraTime(lotteryExtraTime);
        }
        if( created != null ){
            item.setCreated(Tools.convertStringToDate(created, "yyyy-MM-dd HH:mm:ss"));
        }
        if( updated != null ){
            item.setUpdated(Tools.convertStringToDate(updated, "yyyy-MM-dd HH:mm:ss"));
        }
        if( status != null ){
            item.setStatus(status);
        }
        if( isDelete != null ){
            item.setIsDelete(isDelete);
        }
        if( canEdit != null ){
            item.setCanEdit(canEdit);
        }
        tPlatformActivityService.create(item);

        //若request param为null，但字段定义有默认值，则需从数据库中返回结果
        return tPlatformActivityService.get(Integer.valueOf(id));
        //return item;
    }

    @ApiOperation(value = "删除'TPlatformActivity'表中的某条记录", notes = "根据url传入的数据id，删除整条记录。")
    @RequestMapping(value = "/t_platform_activities/{t_platform_activity_id}/delete",
                    method = RequestMethod.POST,
                    produces = "application/json;charset=UTF-8")
    @ResponseBody
    public Object deleteTPlatformActivity(
            @RequestHeader(value = "X-Auth-Token") String token,
            @PathVariable(value = "t_platform_activity_id") Integer id
    ) {
        TPlatformActivity item = tPlatformActivityService.get(id);
        if (null == item) {
            response.setStatus(404);
            return Resp.fail("the asset to be deleted doesn't exist");
        }

        tPlatformActivityService.delete(id);
        return Resp.succ("delete success");
    }

    @ApiOperation(value = "修改'TPlatformActivity'表中的某条记录", notes = "根据url传入的数据id，确定修改表中的某条记录，传入表中字段要修改的信息，不传代表不修改。并返回给View层")
    @RequestMapping(value = "/t_platform_activities/{t_platform_activity_id}/edit",
                    method = RequestMethod.POST,
                    produces = "application/json;charset=UTF-8")
    @ResponseBody
    public Object editTPlatformActivity(
            HttpServletRequest request,
            @RequestHeader(value = "X-Auth-Token") String token,
            @PathVariable(value = "t_platform_activity_id") Integer id,
            @RequestParam(value = "code", required = false) String code,
            @RequestParam(value = "name", required = false) String name,
            @RequestParam(value = "regulation", required = false) String regulation,
            @RequestParam(value = "type", required = false) Integer type,
            @RequestParam(value = "template", required = false) Integer template,
            @RequestParam(value = "startDate", required = false) String startDate,
            @RequestParam(value = "endDate", required = false) String endDate,
            @RequestParam(value = "bannerPath", required = false) String bannerPath,
            @RequestParam(value = "lotteryPlayer", required = false) Integer lotteryPlayer,
            @RequestParam(value = "winningMaxTime", required = false) Integer winningMaxTime,
            @RequestParam(value = "lotteryInitTime", required = false) Integer lotteryInitTime,
            @RequestParam(value = "lotteryExtraTime", required = false) Integer lotteryExtraTime,
            @RequestParam(value = "created", required = false) String created,
            @RequestParam(value = "updated", required = false) String updated,
            @RequestParam(value = "status", required = false) Integer status,
            @RequestParam(value = "isDelete", required = false) Integer isDelete,
            @RequestParam(value = "canEdit", required = false) Integer canEdit
    ) {
        TPlatformActivity item = tPlatformActivityService.get(id);
        if (null == item) {
            response.setStatus(404);
            return Resp.fail("the asset to be edited doesn't exist");
        }

        if( code != null ){
            item.setCode(code);
        }
        if( name != null ){
            item.setName(name);
        }
        if( regulation != null ){
            item.setRegulation(regulation);
        }
        if( type != null ){
            item.setType(type);
        }
        if( template != null ){
            item.setTemplate(template);
        }
        if( startDate != null ){
            item.setStartDate(Tools.convertStringToDate(startDate, "yyyy-MM-dd HH:mm:ss"));
        }
        if( endDate != null ){
            item.setEndDate(Tools.convertStringToDate(endDate, "yyyy-MM-dd HH:mm:ss"));
        }
        if( bannerPath != null ){
            item.setBannerPath(bannerPath);
        }
        if( lotteryPlayer != null ){
            item.setLotteryPlayer(lotteryPlayer);
        }
        if( winningMaxTime != null ){
            item.setWinningMaxTime(winningMaxTime);
        }
        if( lotteryInitTime != null ){
            item.setLotteryInitTime(lotteryInitTime);
        }
        if( lotteryExtraTime != null ){
            item.setLotteryExtraTime(lotteryExtraTime);
        }
        if( created != null ){
            item.setCreated(Tools.convertStringToDate(created, "yyyy-MM-dd HH:mm:ss"));
        }
        if( updated != null ){
            item.setUpdated(Tools.convertStringToDate(updated, "yyyy-MM-dd HH:mm:ss"));
        }
        if( status != null ){
            item.setStatus(status);
        }
        if( isDelete != null ){
            item.setIsDelete(isDelete);
        }
        if( canEdit != null ){
            item.setCanEdit(canEdit);
        }
        tPlatformActivityService.update(item);

        return tPlatformActivityService.get(id);
    }

    @ApiOperation(value = "查询'TPlatformActivity'表中的某条记录", notes = "根据url传入的数据id，查询对应的一条数据。")
    @RequestMapping(value = "/t_platform_activities/{t_platform_activity_id}",
                    method = {RequestMethod.GET, RequestMethod.DELETE, RequestMethod.PUT},
                    produces = "application/json;charset=UTF-8")
    @ResponseBody
    public Object getTPlatformActivity(
            HttpServletRequest request,
            @RequestHeader(value = "X-Auth-Token") String token,
            @PathVariable(value = "t_platform_activity_id") Integer id,
            @RequestParam(value = "code", required = false) String code,
            @RequestParam(value = "name", required = false) String name,
            @RequestParam(value = "regulation", required = false) String regulation,
            @RequestParam(value = "type", required = false) Integer type,
            @RequestParam(value = "template", required = false) Integer template,
            @RequestParam(value = "startDate", required = false) String startDate,
            @RequestParam(value = "endDate", required = false) String endDate,
            @RequestParam(value = "bannerPath", required = false) String bannerPath,
            @RequestParam(value = "lotteryPlayer", required = false) Integer lotteryPlayer,
            @RequestParam(value = "winningMaxTime", required = false) Integer winningMaxTime,
            @RequestParam(value = "lotteryInitTime", required = false) Integer lotteryInitTime,
            @RequestParam(value = "lotteryExtraTime", required = false) Integer lotteryExtraTime,
            @RequestParam(value = "created", required = false) String created,
            @RequestParam(value = "updated", required = false) String updated,
            @RequestParam(value = "status", required = false) Integer status,
            @RequestParam(value = "isDelete", required = false) Integer isDelete,
            @RequestParam(value = "canEdit", required = false) Integer canEdit
    ) {
        if(request.getMethod().equals("GET")){
            TPlatformActivity item = tPlatformActivityService.get(id);
            if (null == item) {
                response.setStatus(404);
                return Resp.fail("the asset to be edited doesn't exist");
            }

            return item;
        }
        else if(request.getMethod().equals("PUT")){
            TPlatformActivity item = tPlatformActivityService.get(id);
            if (null == item) {
                response.setStatus(404);
                return Resp.fail("the asset to be edited doesn't exist");
            }

            if( code != null ){
                item.setCode(code);
            }
            if( name != null ){
                item.setName(name);
            }
            if( regulation != null ){
                item.setRegulation(regulation);
            }
            if( type != null ){
                item.setType(type);
            }
            if( template != null ){
                item.setTemplate(template);
            }
            if( startDate != null ){
                item.setStartDate(Tools.convertStringToDate(startDate, "yyyy-MM-dd HH:mm:ss"));
            }
            if( endDate != null ){
                item.setEndDate(Tools.convertStringToDate(endDate, "yyyy-MM-dd HH:mm:ss"));
            }
            if( bannerPath != null ){
                item.setBannerPath(bannerPath);
            }
            if( lotteryPlayer != null ){
                item.setLotteryPlayer(lotteryPlayer);
            }
            if( winningMaxTime != null ){
                item.setWinningMaxTime(winningMaxTime);
            }
            if( lotteryInitTime != null ){
                item.setLotteryInitTime(lotteryInitTime);
            }
            if( lotteryExtraTime != null ){
                item.setLotteryExtraTime(lotteryExtraTime);
            }
            if( created != null ){
                item.setCreated(Tools.convertStringToDate(created, "yyyy-MM-dd HH:mm:ss"));
            }
            if( updated != null ){
                item.setUpdated(Tools.convertStringToDate(updated, "yyyy-MM-dd HH:mm:ss"));
            }
            if( status != null ){
                item.setStatus(status);
            }
            if( isDelete != null ){
                item.setIsDelete(isDelete);
            }
            if( canEdit != null ){
                item.setCanEdit(canEdit);
            }
            tPlatformActivityService.update(item);

            return tPlatformActivityService.get(id);
        }
        else if(request.getMethod().equals("DELETE")){
            TPlatformActivity item = tPlatformActivityService.get(id);
            if (null == item) {
                response.setStatus(404);
                return Resp.fail("the asset to be deleted doesn't exist");
            }

            tPlatformActivityService.delete(id);
            return Resp.succ("delete success");
        }
        return Resp.fail("Unknown http method");
    }

    @ApiOperation(value = "查询'TPlatformActivity'表中的多条记录或者新增某条记录", notes = "get传参：根据url传入的filters（过滤条件），查询对应的多条数据。数据数量取决于pageNo和pageSize；数据的先后顺序取决于sortItem，sortOrder；   post请求：新增某条记录，传入表字段对应的值")
    @RequestMapping(value = "/t_platform_activities",
                    method = { RequestMethod.GET, RequestMethod.POST },
                    produces = "application/json;charset=UTF-8")
    @ResponseBody
    public Object getTPlatformActivities(
            HttpServletRequest request,
            @RequestHeader(value = "X-Auth-Token", required = false) String token,
            @RequestParam(value = "pageNo", required = false) Integer pageNo,
            @RequestParam(value = "pageSize", required = false) Integer pageSize,
            @RequestParam(value = "sortItem", required = false) String sortItem,
            @RequestParam(value = "sortOrder", required = false) String sortOrder,
            @RequestParam(value = "filters", required = false) String filters,
            @RequestParam(value = "includes", required = false) String includes,
            @RequestParam(value = "refers", required = false) String refers,
            @RequestParam(value = "relates", required = false) String relates
    ) {
        if(pageNo == null){
            pageNo = 1;
        }
        if(pageSize == null){
            pageSize = 10;
        }
        if(sortItem == null){
            sortItem = "id";
        }
        if(sortOrder == null){
            sortOrder = "asc";
        }
        if(filters == null){
            filters = "{}";
        }

        Long total = tPlatformActivityService.countListWithPagingAndFilter(filters);
        response.addHeader("total", String.valueOf(total));

        return tPlatformActivityService.getListWithPagingAndFilter(
                        pageNo, pageSize, sortItem, sortOrder, filters, includes, refers, relates);

    }

    @ApiOperation(value = "出入字段数组返回对应字段数据", notes = "get传参：根据url传入的filters（过滤条件），查询对应的多条数据。只返回你传进来的字段对应的数据")
    @RequestMapping(value = "/t_platform_activities/columns",
                    method = { RequestMethod.GET },
                    produces = "application/json;charset=UTF-8")
    @ResponseBody
    public Object getTPlatformActivitiesId(
            HttpServletRequest request,
            @RequestHeader(value = "X-Auth-Token", required = false) String token,
            @RequestParam(value = "filters", required = true) String filters,
            @RequestParam(value = "columns", required = true) String columns,
            @RequestParam(value = "sortOrder", required = false) String sortOrder,
            @RequestParam(value = "sortItem", required = false) String sortItem,
            @RequestParam(value = "pageNo", required = false) Integer pageNo,
            @RequestParam(value = "pageSize", required = false) Integer pageSize
    ) {
        if(pageNo == null){
            pageNo = 1;
        }
        if(pageSize == null){
            pageSize = 10;
        }
        if(sortOrder==null){
            sortOrder = "asc";
        }
        if(sortItem==null){
            sortItem = "id";
        }
        JSONArray jsonArray = JSON.parseArray(columns);
        List<Map<String,Object>> lists  = new ArrayList<>();
        List<TPlatformActivity> list = tPlatformActivityService.getListWithPagingAndFilter(
                pageNo, pageSize, sortItem, sortOrder, filters);

        //反射调取get方法
        Class clz = TPlatformActivity.class;
        list.stream().forEach(lot->{
            Map<String,Object> map = new HashMap<>();
            for (Object j : jsonArray){
                String s = (String) j;
                s = s.replaceFirst(s.substring(0,1),s.substring(0,1).toUpperCase());
                try {
                    if (clz.getMethod("get"+s).invoke(lot) !=null){
                        map.put((String) j,clz.getMethod("get"+s).invoke(lot));
                    }
                } catch (NoSuchMethodException e) {
                    e.printStackTrace();
                } catch (InvocationTargetException e) {
                    e.printStackTrace();
                } catch (IllegalAccessException e) {
                    e.printStackTrace();
                }
            }
            lists.add(map);
        });

        return lists;
     }



    @ApiOperation(value = "批量创建'TPlatformActivity'表中一条信息", notes = "通过post方法请求，传入表中字段的对应信息，创建一条数据。并返回给View层")
    @RequestMapping(value = "/t_platform_activities/create//batch",
               method = RequestMethod.POST,
               produces = "application/json;charset=UTF-8")
    @ResponseBody
    public Object createsTPlatformActivities(
             HttpServletRequest request,
             @RequestHeader(value = "X-Auth-Token", required = false) String token,
             @RequestParam(value = "params", required = false) String params
    ) {

             JSONArray jsonArray = JSON.parseArray(params);
             List<TPlatformActivity> lists  = new ArrayList<>();

             jsonArray.stream().forEach((Object object) -> {

             JSONObject jsonObject = JSONObject.parseObject(object.toString());

             TPlatformActivity item = new TPlatformActivity();
             String id = Tools.getUUID();
                         item.setId(Integer.valueOf(id));
             if(jsonObject.containsKey("code")   ){
            item.setCode(jsonObject.get("code").toString());
        }
        if(jsonObject.containsKey("name")   ){
            item.setName(jsonObject.get("name").toString());
        }
        if(jsonObject.containsKey("regulation")   ){
            item.setRegulation(jsonObject.get("regulation").toString());
        }
        if(jsonObject.containsKey("type")   ){
            item.setType(Integer.valueOf(jsonObject.get("type").toString()));
        }
        if(jsonObject.containsKey("template")   ){
            item.setTemplate(Integer.valueOf(jsonObject.get("template").toString()));
        }
        if(jsonObject.containsKey("startDate")   ){
            item.setStartDate(Tools.convertStringToDate(jsonObject.get("startDate").toString(), "yyyy-MM-dd HH:mm:ss"));
        }
        if(jsonObject.containsKey("endDate")   ){
            item.setEndDate(Tools.convertStringToDate(jsonObject.get("endDate").toString(), "yyyy-MM-dd HH:mm:ss"));
        }
        if(jsonObject.containsKey("bannerPath")   ){
            item.setBannerPath(jsonObject.get("bannerPath").toString());
        }
        if(jsonObject.containsKey("lotteryPlayer")   ){
            item.setLotteryPlayer(Integer.valueOf(jsonObject.get("lotteryPlayer").toString()));
        }
        if(jsonObject.containsKey("winningMaxTime")   ){
            item.setWinningMaxTime(Integer.valueOf(jsonObject.get("winningMaxTime").toString()));
        }
        if(jsonObject.containsKey("lotteryInitTime")   ){
            item.setLotteryInitTime(Integer.valueOf(jsonObject.get("lotteryInitTime").toString()));
        }
        if(jsonObject.containsKey("lotteryExtraTime")   ){
            item.setLotteryExtraTime(Integer.valueOf(jsonObject.get("lotteryExtraTime").toString()));
        }
        if(jsonObject.containsKey("created")   ){
            item.setCreated(Tools.convertStringToDate(jsonObject.get("created").toString(), "yyyy-MM-dd HH:mm:ss"));
        }
        if(jsonObject.containsKey("updated")   ){
            item.setUpdated(Tools.convertStringToDate(jsonObject.get("updated").toString(), "yyyy-MM-dd HH:mm:ss"));
        }
        if(jsonObject.containsKey("status")   ){
            item.setStatus(Integer.valueOf(jsonObject.get("status").toString()));
        }
        if(jsonObject.containsKey("isDelete")   ){
            item.setIsDelete(Integer.valueOf(jsonObject.get("isDelete").toString()));
        }
        if(jsonObject.containsKey("canEdit")   ){
            item.setCanEdit(Integer.valueOf(jsonObject.get("canEdit").toString()));
        }
             tPlatformActivityService.create(item);
             lists.add(tPlatformActivityService.get(Integer.valueOf(id)));

             });
        return lists;
     }

    @ApiOperation(value = "批量删除'TPlatformActivity'表中一条信息", notes = "通过post方法请求，传入表中字段的对应信息，创建一条数据。并返回给View层")
        @RequestMapping(value = "/t_platform_activities/delete/batch",
                method = RequestMethod.POST,
                produces = "application/json;charset=UTF-8")
        @ResponseBody
        public Object deletesTPlatformActivity(
                HttpServletRequest request,
                @RequestHeader(value = "X-Auth-Token", required = false) String token,
                @RequestParam(value = "ids", required = true) String ids
        ) {

            JSONArray jsonArray = JSON.parseArray(ids);
            jsonArray.stream().forEach(id->{

                 TPlatformActivity item = tPlatformActivityService.get(Integer.valueOf(id.toString()));
                if (null != item) {
                    tPlatformActivityService.delete(Integer.valueOf(id.toString()));
                }

            });
            return Resp.succ("delete success");
        }
}
