package com.haomostudio.so.controller;

import com.haomostudio.so.common.Resp;
import com.haomostudio.so.po.TPlatformVerifyStation;
import com.haomostudio.so.service.TPlatformVerifyStationService;
import com.haomostudio.so.service.HmUtils.Tools;
import com.alibaba.fastjson.*;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.lang.reflect.InvocationTargetException;
import java.text.SimpleDateFormat;
import java.util.*;

/**
 * Created by hxg on 2016/10/06.
 */
@Api(description = "TPlatformVerifyStation")
@Controller
public class TPlatformVerifyStationController {

    @Autowired
    TPlatformVerifyStationService tPlatformVerifyStationService;

    @Autowired
    HttpServletResponse response;

    @ApiOperation(value = "创建'TPlatformVerifyStation'表中一条信息", notes = "通过post方法请求，传入表中字段的对应信息，创建一条数据。并返回给View层")
    @RequestMapping(value = "/t_platform_verify_stations/new",
                    method = RequestMethod.POST,
                    produces = "application/json;charset=UTF-8")
    @ResponseBody
    public Object createTPlatformVerifyStation(
            HttpServletRequest request,
            @RequestHeader(value = "X-Auth-Token") String token,
            @RequestParam(value = "name", required = false) String name,
            @RequestParam(value = "spaceId", required = false) Integer spaceId,
            @RequestParam(value = "storeId", required = false) Integer storeId,
            @RequestParam(value = "provinceCode", required = false) String provinceCode,
            @RequestParam(value = "provinceName", required = false) String provinceName,
            @RequestParam(value = "cityCode", required = false) String cityCode,
            @RequestParam(value = "cityName", required = false) String cityName,
            @RequestParam(value = "districtCode", required = false) String districtCode,
            @RequestParam(value = "districtName", required = false) String districtName,
            @RequestParam(value = "address", required = false) String address,
            @RequestParam(value = "status", required = false) Integer status,
            @RequestParam(value = "isDelete", required = false) Integer isDelete,
            @RequestParam(value = "created", required = false) String created,
            @RequestParam(value = "updated", required = false) String updated
    ) {
        TPlatformVerifyStation item = new TPlatformVerifyStation();
        String id = Tools.getUUID();
        item.setId(Integer.valueOf(id));
        if( name != null ){
            item.setName(name);
        }
        if( spaceId != null ){
            item.setSpaceId(spaceId);
        }
        if( storeId != null ){
            item.setStoreId(storeId);
        }
        if( provinceCode != null ){
            item.setProvinceCode(provinceCode);
        }
        if( provinceName != null ){
            item.setProvinceName(provinceName);
        }
        if( cityCode != null ){
            item.setCityCode(cityCode);
        }
        if( cityName != null ){
            item.setCityName(cityName);
        }
        if( districtCode != null ){
            item.setDistrictCode(districtCode);
        }
        if( districtName != null ){
            item.setDistrictName(districtName);
        }
        if( address != null ){
            item.setAddress(address);
        }
        if( status != null ){
            item.setStatus(status);
        }
        if( isDelete != null ){
            item.setIsDelete(isDelete);
        }
        if( created != null ){
            item.setCreated(Tools.convertStringToDate(created, "yyyy-MM-dd HH:mm:ss"));
        }
        if( updated != null ){
            item.setUpdated(Tools.convertStringToDate(updated, "yyyy-MM-dd HH:mm:ss"));
        }
        tPlatformVerifyStationService.create(item);

        //若request param为null，但字段定义有默认值，则需从数据库中返回结果
        return tPlatformVerifyStationService.get(Integer.valueOf(id));
        //return item;
    }

    @ApiOperation(value = "删除'TPlatformVerifyStation'表中的某条记录", notes = "根据url传入的数据id，删除整条记录。")
    @RequestMapping(value = "/t_platform_verify_stations/{t_platform_verify_station_id}/delete",
                    method = RequestMethod.POST,
                    produces = "application/json;charset=UTF-8")
    @ResponseBody
    public Object deleteTPlatformVerifyStation(
            @RequestHeader(value = "X-Auth-Token") String token,
            @PathVariable(value = "t_platform_verify_station_id") Integer id
    ) {
        TPlatformVerifyStation item = tPlatformVerifyStationService.get(id);
        if (null == item) {
            response.setStatus(404);
            return Resp.fail("the asset to be deleted doesn't exist");
        }

        tPlatformVerifyStationService.delete(id);
        return Resp.succ("delete success");
    }

    @ApiOperation(value = "修改'TPlatformVerifyStation'表中的某条记录", notes = "根据url传入的数据id，确定修改表中的某条记录，传入表中字段要修改的信息，不传代表不修改。并返回给View层")
    @RequestMapping(value = "/t_platform_verify_stations/{t_platform_verify_station_id}/edit",
                    method = RequestMethod.POST,
                    produces = "application/json;charset=UTF-8")
    @ResponseBody
    public Object editTPlatformVerifyStation(
            HttpServletRequest request,
            @RequestHeader(value = "X-Auth-Token") String token,
            @PathVariable(value = "t_platform_verify_station_id") Integer id,
            @RequestParam(value = "name", required = false) String name,
            @RequestParam(value = "spaceId", required = false) Integer spaceId,
            @RequestParam(value = "storeId", required = false) Integer storeId,
            @RequestParam(value = "provinceCode", required = false) String provinceCode,
            @RequestParam(value = "provinceName", required = false) String provinceName,
            @RequestParam(value = "cityCode", required = false) String cityCode,
            @RequestParam(value = "cityName", required = false) String cityName,
            @RequestParam(value = "districtCode", required = false) String districtCode,
            @RequestParam(value = "districtName", required = false) String districtName,
            @RequestParam(value = "address", required = false) String address,
            @RequestParam(value = "status", required = false) Integer status,
            @RequestParam(value = "isDelete", required = false) Integer isDelete,
            @RequestParam(value = "created", required = false) String created,
            @RequestParam(value = "updated", required = false) String updated
    ) {
        TPlatformVerifyStation item = tPlatformVerifyStationService.get(id);
        if (null == item) {
            response.setStatus(404);
            return Resp.fail("the asset to be edited doesn't exist");
        }

        if( name != null ){
            item.setName(name);
        }
        if( spaceId != null ){
            item.setSpaceId(spaceId);
        }
        if( storeId != null ){
            item.setStoreId(storeId);
        }
        if( provinceCode != null ){
            item.setProvinceCode(provinceCode);
        }
        if( provinceName != null ){
            item.setProvinceName(provinceName);
        }
        if( cityCode != null ){
            item.setCityCode(cityCode);
        }
        if( cityName != null ){
            item.setCityName(cityName);
        }
        if( districtCode != null ){
            item.setDistrictCode(districtCode);
        }
        if( districtName != null ){
            item.setDistrictName(districtName);
        }
        if( address != null ){
            item.setAddress(address);
        }
        if( status != null ){
            item.setStatus(status);
        }
        if( isDelete != null ){
            item.setIsDelete(isDelete);
        }
        if( created != null ){
            item.setCreated(Tools.convertStringToDate(created, "yyyy-MM-dd HH:mm:ss"));
        }
        if( updated != null ){
            item.setUpdated(Tools.convertStringToDate(updated, "yyyy-MM-dd HH:mm:ss"));
        }
        tPlatformVerifyStationService.update(item);

        return tPlatformVerifyStationService.get(id);
    }

    @ApiOperation(value = "查询'TPlatformVerifyStation'表中的某条记录", notes = "根据url传入的数据id，查询对应的一条数据。")
    @RequestMapping(value = "/t_platform_verify_stations/{t_platform_verify_station_id}",
                    method = {RequestMethod.GET, RequestMethod.DELETE, RequestMethod.PUT},
                    produces = "application/json;charset=UTF-8")
    @ResponseBody
    public Object getTPlatformVerifyStation(
            HttpServletRequest request,
            @RequestHeader(value = "X-Auth-Token") String token,
            @PathVariable(value = "t_platform_verify_station_id") Integer id,
            @RequestParam(value = "name", required = false) String name,
            @RequestParam(value = "spaceId", required = false) Integer spaceId,
            @RequestParam(value = "storeId", required = false) Integer storeId,
            @RequestParam(value = "provinceCode", required = false) String provinceCode,
            @RequestParam(value = "provinceName", required = false) String provinceName,
            @RequestParam(value = "cityCode", required = false) String cityCode,
            @RequestParam(value = "cityName", required = false) String cityName,
            @RequestParam(value = "districtCode", required = false) String districtCode,
            @RequestParam(value = "districtName", required = false) String districtName,
            @RequestParam(value = "address", required = false) String address,
            @RequestParam(value = "status", required = false) Integer status,
            @RequestParam(value = "isDelete", required = false) Integer isDelete,
            @RequestParam(value = "created", required = false) String created,
            @RequestParam(value = "updated", required = false) String updated
    ) {
        if(request.getMethod().equals("GET")){
            TPlatformVerifyStation item = tPlatformVerifyStationService.get(id);
            if (null == item) {
                response.setStatus(404);
                return Resp.fail("the asset to be edited doesn't exist");
            }

            return item;
        }
        else if(request.getMethod().equals("PUT")){
            TPlatformVerifyStation item = tPlatformVerifyStationService.get(id);
            if (null == item) {
                response.setStatus(404);
                return Resp.fail("the asset to be edited doesn't exist");
            }

            if( name != null ){
                item.setName(name);
            }
            if( spaceId != null ){
                item.setSpaceId(spaceId);
            }
            if( storeId != null ){
                item.setStoreId(storeId);
            }
            if( provinceCode != null ){
                item.setProvinceCode(provinceCode);
            }
            if( provinceName != null ){
                item.setProvinceName(provinceName);
            }
            if( cityCode != null ){
                item.setCityCode(cityCode);
            }
            if( cityName != null ){
                item.setCityName(cityName);
            }
            if( districtCode != null ){
                item.setDistrictCode(districtCode);
            }
            if( districtName != null ){
                item.setDistrictName(districtName);
            }
            if( address != null ){
                item.setAddress(address);
            }
            if( status != null ){
                item.setStatus(status);
            }
            if( isDelete != null ){
                item.setIsDelete(isDelete);
            }
            if( created != null ){
                item.setCreated(Tools.convertStringToDate(created, "yyyy-MM-dd HH:mm:ss"));
            }
            if( updated != null ){
                item.setUpdated(Tools.convertStringToDate(updated, "yyyy-MM-dd HH:mm:ss"));
            }
            tPlatformVerifyStationService.update(item);

            return tPlatformVerifyStationService.get(id);
        }
        else if(request.getMethod().equals("DELETE")){
            TPlatformVerifyStation item = tPlatformVerifyStationService.get(id);
            if (null == item) {
                response.setStatus(404);
                return Resp.fail("the asset to be deleted doesn't exist");
            }

            tPlatformVerifyStationService.delete(id);
            return Resp.succ("delete success");
        }
        return Resp.fail("Unknown http method");
    }

    @ApiOperation(value = "查询'TPlatformVerifyStation'表中的多条记录或者新增某条记录", notes = "get传参：根据url传入的filters（过滤条件），查询对应的多条数据。数据数量取决于pageNo和pageSize；数据的先后顺序取决于sortItem，sortOrder；   post请求：新增某条记录，传入表字段对应的值")
    @RequestMapping(value = "/t_platform_verify_stations",
                    method = { RequestMethod.GET, RequestMethod.POST },
                    produces = "application/json;charset=UTF-8")
    @ResponseBody
    public Object getTPlatformVerifyStations(
            HttpServletRequest request,
            @RequestHeader(value = "X-Auth-Token", required = false) String token,
            @RequestParam(value = "pageNo", required = false) Integer pageNo,
            @RequestParam(value = "pageSize", required = false) Integer pageSize,
            @RequestParam(value = "sortItem", required = false) String sortItem,
            @RequestParam(value = "sortOrder", required = false) String sortOrder,
            @RequestParam(value = "filters", required = false) String filters,
            @RequestParam(value = "includes", required = false) String includes,
            @RequestParam(value = "refers", required = false) String refers,
            @RequestParam(value = "relates", required = false) String relates
    ) {
        if(pageNo == null){
            pageNo = 1;
        }
        if(pageSize == null){
            pageSize = 10;
        }
        if(sortItem == null){
            sortItem = "id";
        }
        if(sortOrder == null){
            sortOrder = "asc";
        }
        if(filters == null){
            filters = "{}";
        }

        Long total = tPlatformVerifyStationService.countListWithPagingAndFilter(filters);
        response.addHeader("total", String.valueOf(total));

        return tPlatformVerifyStationService.getListWithPagingAndFilter(
                        pageNo, pageSize, sortItem, sortOrder, filters, includes, refers, relates);

    }

    @ApiOperation(value = "出入字段数组返回对应字段数据", notes = "get传参：根据url传入的filters（过滤条件），查询对应的多条数据。只返回你传进来的字段对应的数据")
    @RequestMapping(value = "/t_platform_verify_stations/columns",
                    method = { RequestMethod.GET },
                    produces = "application/json;charset=UTF-8")
    @ResponseBody
    public Object getTPlatformVerifyStationsId(
            HttpServletRequest request,
            @RequestHeader(value = "X-Auth-Token", required = false) String token,
            @RequestParam(value = "filters", required = true) String filters,
            @RequestParam(value = "columns", required = true) String columns,
            @RequestParam(value = "sortOrder", required = false) String sortOrder,
            @RequestParam(value = "sortItem", required = false) String sortItem,
            @RequestParam(value = "pageNo", required = false) Integer pageNo,
            @RequestParam(value = "pageSize", required = false) Integer pageSize
    ) {
        if(pageNo == null){
            pageNo = 1;
        }
        if(pageSize == null){
            pageSize = 10;
        }
        if(sortOrder==null){
            sortOrder = "asc";
        }
        if(sortItem==null){
            sortItem = "id";
        }
        JSONArray jsonArray = JSON.parseArray(columns);
        List<Map<String,Object>> lists  = new ArrayList<>();
        List<TPlatformVerifyStation> list = tPlatformVerifyStationService.getListWithPagingAndFilter(
                pageNo, pageSize, sortItem, sortOrder, filters);

        //反射调取get方法
        Class clz = TPlatformVerifyStation.class;
        list.stream().forEach(lot->{
            Map<String,Object> map = new HashMap<>();
            for (Object j : jsonArray){
                String s = (String) j;
                s = s.replaceFirst(s.substring(0,1),s.substring(0,1).toUpperCase());
                try {
                    if (clz.getMethod("get"+s).invoke(lot) !=null){
                        map.put((String) j,clz.getMethod("get"+s).invoke(lot));
                    }
                } catch (NoSuchMethodException e) {
                    e.printStackTrace();
                } catch (InvocationTargetException e) {
                    e.printStackTrace();
                } catch (IllegalAccessException e) {
                    e.printStackTrace();
                }
            }
            lists.add(map);
        });

        return lists;
     }



    @ApiOperation(value = "批量创建'TPlatformVerifyStation'表中一条信息", notes = "通过post方法请求，传入表中字段的对应信息，创建一条数据。并返回给View层")
    @RequestMapping(value = "/t_platform_verify_stations/create//batch",
               method = RequestMethod.POST,
               produces = "application/json;charset=UTF-8")
    @ResponseBody
    public Object createsTPlatformVerifyStations(
             HttpServletRequest request,
             @RequestHeader(value = "X-Auth-Token", required = false) String token,
             @RequestParam(value = "params", required = false) String params
    ) {

             JSONArray jsonArray = JSON.parseArray(params);
             List<TPlatformVerifyStation> lists  = new ArrayList<>();

             jsonArray.stream().forEach((Object object) -> {

             JSONObject jsonObject = JSONObject.parseObject(object.toString());

             TPlatformVerifyStation item = new TPlatformVerifyStation();
             String id = Tools.getUUID();
                         item.setId(Integer.valueOf(id));
             if(jsonObject.containsKey("name")   ){
            item.setName(jsonObject.get("name").toString());
        }
        if(jsonObject.containsKey("spaceId")   ){
            item.setSpaceId(Integer.valueOf(jsonObject.get("spaceId").toString()));
        }
        if(jsonObject.containsKey("storeId")   ){
            item.setStoreId(Integer.valueOf(jsonObject.get("storeId").toString()));
        }
        if(jsonObject.containsKey("provinceCode")   ){
            item.setProvinceCode(jsonObject.get("provinceCode").toString());
        }
        if(jsonObject.containsKey("provinceName")   ){
            item.setProvinceName(jsonObject.get("provinceName").toString());
        }
        if(jsonObject.containsKey("cityCode")   ){
            item.setCityCode(jsonObject.get("cityCode").toString());
        }
        if(jsonObject.containsKey("cityName")   ){
            item.setCityName(jsonObject.get("cityName").toString());
        }
        if(jsonObject.containsKey("districtCode")   ){
            item.setDistrictCode(jsonObject.get("districtCode").toString());
        }
        if(jsonObject.containsKey("districtName")   ){
            item.setDistrictName(jsonObject.get("districtName").toString());
        }
        if(jsonObject.containsKey("address")   ){
            item.setAddress(jsonObject.get("address").toString());
        }
        if(jsonObject.containsKey("status")   ){
            item.setStatus(Integer.valueOf(jsonObject.get("status").toString()));
        }
        if(jsonObject.containsKey("isDelete")   ){
            item.setIsDelete(Integer.valueOf(jsonObject.get("isDelete").toString()));
        }
        if(jsonObject.containsKey("created")   ){
            item.setCreated(Tools.convertStringToDate(jsonObject.get("created").toString(), "yyyy-MM-dd HH:mm:ss"));
        }
        if(jsonObject.containsKey("updated")   ){
            item.setUpdated(Tools.convertStringToDate(jsonObject.get("updated").toString(), "yyyy-MM-dd HH:mm:ss"));
        }
             tPlatformVerifyStationService.create(item);
             lists.add(tPlatformVerifyStationService.get(Integer.valueOf(id)));

             });
        return lists;
     }

    @ApiOperation(value = "批量删除'TPlatformVerifyStation'表中一条信息", notes = "通过post方法请求，传入表中字段的对应信息，创建一条数据。并返回给View层")
        @RequestMapping(value = "/t_platform_verify_stations/delete/batch",
                method = RequestMethod.POST,
                produces = "application/json;charset=UTF-8")
        @ResponseBody
        public Object deletesTPlatformVerifyStation(
                HttpServletRequest request,
                @RequestHeader(value = "X-Auth-Token", required = false) String token,
                @RequestParam(value = "ids", required = true) String ids
        ) {

            JSONArray jsonArray = JSON.parseArray(ids);
            jsonArray.stream().forEach(id->{

                 TPlatformVerifyStation item = tPlatformVerifyStationService.get(Integer.valueOf(id.toString()));
                if (null != item) {
                    tPlatformVerifyStationService.delete(Integer.valueOf(id.toString()));
                }

            });
            return Resp.succ("delete success");
        }
}
