package com.haomostudio.so.controller;

import com.haomostudio.so.common.Resp;
import com.haomostudio.so.po.TSpaceKeeperCompany;
import com.haomostudio.so.service.TSpaceKeeperCompanyService;
import com.haomostudio.so.service.HmUtils.Tools;
import com.alibaba.fastjson.*;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.lang.reflect.InvocationTargetException;
import java.text.SimpleDateFormat;
import java.util.*;

/**
 * Created by hxg on 2016/10/06.
 */
@Api(description = "TSpaceKeeperCompany")
@Controller
public class TSpaceKeeperCompanyController {

    @Autowired
    TSpaceKeeperCompanyService tSpaceKeeperCompanyService;

    @Autowired
    HttpServletResponse response;

    @ApiOperation(value = "创建'TSpaceKeeperCompany'表中一条信息", notes = "通过post方法请求，传入表中字段的对应信息，创建一条数据。并返回给View层")
    @RequestMapping(value = "/t_space_keeper_companies/new",
                    method = RequestMethod.POST,
                    produces = "application/json;charset=UTF-8")
    @ResponseBody
    public Object createTSpaceKeeperCompany(
            HttpServletRequest request,
            @RequestHeader(value = "X-Auth-Token") String token,
            @RequestParam(value = "spaceKeeperId", required = false) Integer spaceKeeperId,
            @RequestParam(value = "spaceKeeperName", required = false) String spaceKeeperName,
            @RequestParam(value = "spaceId", required = false) Integer spaceId,
            @RequestParam(value = "companyId", required = false) Integer companyId,
            @RequestParam(value = "companyName", required = false) String companyName,
            @RequestParam(value = "storeId", required = false) Integer storeId,
            @RequestParam(value = "storeName", required = false) String storeName,
            @RequestParam(value = "companyContact", required = false) String companyContact,
            @RequestParam(value = "companyPhone", required = false) String companyPhone,
            @RequestParam(value = "isDelete", required = false) Integer isDelete,
            @RequestParam(value = "createTime", required = false) String createTime,
            @RequestParam(value = "modifiedTime", required = false) String modifiedTime
    ) {
        TSpaceKeeperCompany item = new TSpaceKeeperCompany();
        String id = Tools.getUUID();
        item.setId(Integer.valueOf(id));
        if( spaceKeeperId != null ){
            item.setSpaceKeeperId(spaceKeeperId);
        }
        if( spaceKeeperName != null ){
            item.setSpaceKeeperName(spaceKeeperName);
        }
        if( spaceId != null ){
            item.setSpaceId(spaceId);
        }
        if( companyId != null ){
            item.setCompanyId(companyId);
        }
        if( companyName != null ){
            item.setCompanyName(companyName);
        }
        if( storeId != null ){
            item.setStoreId(storeId);
        }
        if( storeName != null ){
            item.setStoreName(storeName);
        }
        if( companyContact != null ){
            item.setCompanyContact(companyContact);
        }
        if( companyPhone != null ){
            item.setCompanyPhone(companyPhone);
        }
        if( isDelete != null ){
            item.setIsDelete(isDelete);
        }
            item.setCreateTime(new Date());
        if( modifiedTime != null ){
            item.setModifiedTime(Tools.convertStringToDate(modifiedTime, "yyyy-MM-dd HH:mm:ss"));
        }
        tSpaceKeeperCompanyService.create(item);

        //若request param为null，但字段定义有默认值，则需从数据库中返回结果
        return tSpaceKeeperCompanyService.get(Integer.valueOf(id));
        //return item;
    }

    @ApiOperation(value = "删除'TSpaceKeeperCompany'表中的某条记录", notes = "根据url传入的数据id，删除整条记录。")
    @RequestMapping(value = "/t_space_keeper_companies/{t_space_keeper_company_id}/delete",
                    method = RequestMethod.POST,
                    produces = "application/json;charset=UTF-8")
    @ResponseBody
    public Object deleteTSpaceKeeperCompany(
            @RequestHeader(value = "X-Auth-Token") String token,
            @PathVariable(value = "t_space_keeper_company_id") Integer id
    ) {
        TSpaceKeeperCompany item = tSpaceKeeperCompanyService.get(id);
        if (null == item) {
            response.setStatus(404);
            return Resp.fail("the asset to be deleted doesn't exist");
        }

        tSpaceKeeperCompanyService.delete(id);
        return Resp.succ("delete success");
    }

    @ApiOperation(value = "修改'TSpaceKeeperCompany'表中的某条记录", notes = "根据url传入的数据id，确定修改表中的某条记录，传入表中字段要修改的信息，不传代表不修改。并返回给View层")
    @RequestMapping(value = "/t_space_keeper_companies/{t_space_keeper_company_id}/edit",
                    method = RequestMethod.POST,
                    produces = "application/json;charset=UTF-8")
    @ResponseBody
    public Object editTSpaceKeeperCompany(
            HttpServletRequest request,
            @RequestHeader(value = "X-Auth-Token") String token,
            @PathVariable(value = "t_space_keeper_company_id") Integer id,
            @RequestParam(value = "spaceKeeperId", required = false) Integer spaceKeeperId,
            @RequestParam(value = "spaceKeeperName", required = false) String spaceKeeperName,
            @RequestParam(value = "spaceId", required = false) Integer spaceId,
            @RequestParam(value = "companyId", required = false) Integer companyId,
            @RequestParam(value = "companyName", required = false) String companyName,
            @RequestParam(value = "storeId", required = false) Integer storeId,
            @RequestParam(value = "storeName", required = false) String storeName,
            @RequestParam(value = "companyContact", required = false) String companyContact,
            @RequestParam(value = "companyPhone", required = false) String companyPhone,
            @RequestParam(value = "isDelete", required = false) Integer isDelete,
            @RequestParam(value = "modifiedTime", required = false) String modifiedTime
    ) {
        TSpaceKeeperCompany item = tSpaceKeeperCompanyService.get(id);
        if (null == item) {
            response.setStatus(404);
            return Resp.fail("the asset to be edited doesn't exist");
        }

        if( spaceKeeperId != null ){
            item.setSpaceKeeperId(spaceKeeperId);
        }
        if( spaceKeeperName != null ){
            item.setSpaceKeeperName(spaceKeeperName);
        }
        if( spaceId != null ){
            item.setSpaceId(spaceId);
        }
        if( companyId != null ){
            item.setCompanyId(companyId);
        }
        if( companyName != null ){
            item.setCompanyName(companyName);
        }
        if( storeId != null ){
            item.setStoreId(storeId);
        }
        if( storeName != null ){
            item.setStoreName(storeName);
        }
        if( companyContact != null ){
            item.setCompanyContact(companyContact);
        }
        if( companyPhone != null ){
            item.setCompanyPhone(companyPhone);
        }
        if( isDelete != null ){
            item.setIsDelete(isDelete);
        }
        if( modifiedTime != null ){
            item.setModifiedTime(Tools.convertStringToDate(modifiedTime, "yyyy-MM-dd HH:mm:ss"));
        }
        tSpaceKeeperCompanyService.update(item);

        return tSpaceKeeperCompanyService.get(id);
    }

    @ApiOperation(value = "查询'TSpaceKeeperCompany'表中的某条记录", notes = "根据url传入的数据id，查询对应的一条数据。")
    @RequestMapping(value = "/t_space_keeper_companies/{t_space_keeper_company_id}",
                    method = {RequestMethod.GET, RequestMethod.DELETE, RequestMethod.PUT},
                    produces = "application/json;charset=UTF-8")
    @ResponseBody
    public Object getTSpaceKeeperCompany(
            HttpServletRequest request,
            @RequestHeader(value = "X-Auth-Token") String token,
            @PathVariable(value = "t_space_keeper_company_id") Integer id,
            @RequestParam(value = "spaceKeeperId", required = false) Integer spaceKeeperId,
            @RequestParam(value = "spaceKeeperName", required = false) String spaceKeeperName,
            @RequestParam(value = "spaceId", required = false) Integer spaceId,
            @RequestParam(value = "companyId", required = false) Integer companyId,
            @RequestParam(value = "companyName", required = false) String companyName,
            @RequestParam(value = "storeId", required = false) Integer storeId,
            @RequestParam(value = "storeName", required = false) String storeName,
            @RequestParam(value = "companyContact", required = false) String companyContact,
            @RequestParam(value = "companyPhone", required = false) String companyPhone,
            @RequestParam(value = "isDelete", required = false) Integer isDelete,
            @RequestParam(value = "modifiedTime", required = false) String modifiedTime
    ) {
        if(request.getMethod().equals("GET")){
            TSpaceKeeperCompany item = tSpaceKeeperCompanyService.get(id);
            if (null == item) {
                response.setStatus(404);
                return Resp.fail("the asset to be edited doesn't exist");
            }

            return item;
        }
        else if(request.getMethod().equals("PUT")){
            TSpaceKeeperCompany item = tSpaceKeeperCompanyService.get(id);
            if (null == item) {
                response.setStatus(404);
                return Resp.fail("the asset to be edited doesn't exist");
            }

            if( spaceKeeperId != null ){
                item.setSpaceKeeperId(spaceKeeperId);
            }
            if( spaceKeeperName != null ){
                item.setSpaceKeeperName(spaceKeeperName);
            }
            if( spaceId != null ){
                item.setSpaceId(spaceId);
            }
            if( companyId != null ){
                item.setCompanyId(companyId);
            }
            if( companyName != null ){
                item.setCompanyName(companyName);
            }
            if( storeId != null ){
                item.setStoreId(storeId);
            }
            if( storeName != null ){
                item.setStoreName(storeName);
            }
            if( companyContact != null ){
                item.setCompanyContact(companyContact);
            }
            if( companyPhone != null ){
                item.setCompanyPhone(companyPhone);
            }
            if( isDelete != null ){
                item.setIsDelete(isDelete);
            }
            if( modifiedTime != null ){
                item.setModifiedTime(Tools.convertStringToDate(modifiedTime, "yyyy-MM-dd HH:mm:ss"));
            }
            tSpaceKeeperCompanyService.update(item);

            return tSpaceKeeperCompanyService.get(id);
        }
        else if(request.getMethod().equals("DELETE")){
            TSpaceKeeperCompany item = tSpaceKeeperCompanyService.get(id);
            if (null == item) {
                response.setStatus(404);
                return Resp.fail("the asset to be deleted doesn't exist");
            }

            tSpaceKeeperCompanyService.delete(id);
            return Resp.succ("delete success");
        }
        return Resp.fail("Unknown http method");
    }

    @ApiOperation(value = "查询'TSpaceKeeperCompany'表中的多条记录或者新增某条记录", notes = "get传参：根据url传入的filters（过滤条件），查询对应的多条数据。数据数量取决于pageNo和pageSize；数据的先后顺序取决于sortItem，sortOrder；   post请求：新增某条记录，传入表字段对应的值")
    @RequestMapping(value = "/t_space_keeper_companies",
                    method = { RequestMethod.GET, RequestMethod.POST },
                    produces = "application/json;charset=UTF-8")
    @ResponseBody
    public Object getTSpaceKeeperCompanies(
            HttpServletRequest request,
            @RequestHeader(value = "X-Auth-Token", required = false) String token,
            @RequestParam(value = "pageNo", required = false) Integer pageNo,
            @RequestParam(value = "pageSize", required = false) Integer pageSize,
            @RequestParam(value = "sortItem", required = false) String sortItem,
            @RequestParam(value = "sortOrder", required = false) String sortOrder,
            @RequestParam(value = "filters", required = false) String filters,
            @RequestParam(value = "includes", required = false) String includes,
            @RequestParam(value = "refers", required = false) String refers,
            @RequestParam(value = "relates", required = false) String relates
    ) {
        if(pageNo == null){
            pageNo = 1;
        }
        if(pageSize == null){
            pageSize = 10;
        }
        if(sortItem == null){
            sortItem = "id";
        }
        if(sortOrder == null){
            sortOrder = "asc";
        }
        if(filters == null){
            filters = "{}";
        }

        Long total = tSpaceKeeperCompanyService.countListWithPagingAndFilter(filters);
        response.addHeader("total", String.valueOf(total));

        return tSpaceKeeperCompanyService.getListWithPagingAndFilter(
                        pageNo, pageSize, sortItem, sortOrder, filters, includes, refers, relates);

    }

    @ApiOperation(value = "出入字段数组返回对应字段数据", notes = "get传参：根据url传入的filters（过滤条件），查询对应的多条数据。只返回你传进来的字段对应的数据")
    @RequestMapping(value = "/t_space_keeper_companies/columns",
                    method = { RequestMethod.GET },
                    produces = "application/json;charset=UTF-8")
    @ResponseBody
    public Object getTSpaceKeeperCompaniesId(
            HttpServletRequest request,
            @RequestHeader(value = "X-Auth-Token", required = false) String token,
            @RequestParam(value = "filters", required = true) String filters,
            @RequestParam(value = "columns", required = true) String columns,
            @RequestParam(value = "sortOrder", required = false) String sortOrder,
            @RequestParam(value = "sortItem", required = false) String sortItem,
            @RequestParam(value = "pageNo", required = false) Integer pageNo,
            @RequestParam(value = "pageSize", required = false) Integer pageSize
    ) {
        if(pageNo == null){
            pageNo = 1;
        }
        if(pageSize == null){
            pageSize = 10;
        }
        if(sortOrder==null){
            sortOrder = "asc";
        }
        if(sortItem==null){
            sortItem = "id";
        }
        JSONArray jsonArray = JSON.parseArray(columns);
        List<Map<String,Object>> lists  = new ArrayList<>();
        List<TSpaceKeeperCompany> list = tSpaceKeeperCompanyService.getListWithPagingAndFilter(
                pageNo, pageSize, sortItem, sortOrder, filters);

        //反射调取get方法
        Class clz = TSpaceKeeperCompany.class;
        list.stream().forEach(lot->{
            Map<String,Object> map = new HashMap<>();
            for (Object j : jsonArray){
                String s = (String) j;
                s = s.replaceFirst(s.substring(0,1),s.substring(0,1).toUpperCase());
                try {
                    if (clz.getMethod("get"+s).invoke(lot) !=null){
                        map.put((String) j,clz.getMethod("get"+s).invoke(lot));
                    }
                } catch (NoSuchMethodException e) {
                    e.printStackTrace();
                } catch (InvocationTargetException e) {
                    e.printStackTrace();
                } catch (IllegalAccessException e) {
                    e.printStackTrace();
                }
            }
            lists.add(map);
        });

        return lists;
     }



    @ApiOperation(value = "批量创建'TSpaceKeeperCompany'表中一条信息", notes = "通过post方法请求，传入表中字段的对应信息，创建一条数据。并返回给View层")
    @RequestMapping(value = "/t_space_keeper_companies/create//batch",
               method = RequestMethod.POST,
               produces = "application/json;charset=UTF-8")
    @ResponseBody
    public Object createsTSpaceKeeperCompanies(
             HttpServletRequest request,
             @RequestHeader(value = "X-Auth-Token", required = false) String token,
             @RequestParam(value = "params", required = false) String params
    ) {

             JSONArray jsonArray = JSON.parseArray(params);
             List<TSpaceKeeperCompany> lists  = new ArrayList<>();

             jsonArray.stream().forEach((Object object) -> {

             JSONObject jsonObject = JSONObject.parseObject(object.toString());

             TSpaceKeeperCompany item = new TSpaceKeeperCompany();
             String id = Tools.getUUID();
                         item.setId(Integer.valueOf(id));
             if(jsonObject.containsKey("spaceKeeperId")   ){
            item.setSpaceKeeperId(Integer.valueOf(jsonObject.get("spaceKeeperId").toString()));
        }
        if(jsonObject.containsKey("spaceKeeperName")   ){
            item.setSpaceKeeperName(jsonObject.get("spaceKeeperName").toString());
        }
        if(jsonObject.containsKey("spaceId")   ){
            item.setSpaceId(Integer.valueOf(jsonObject.get("spaceId").toString()));
        }
        if(jsonObject.containsKey("companyId")   ){
            item.setCompanyId(Integer.valueOf(jsonObject.get("companyId").toString()));
        }
        if(jsonObject.containsKey("companyName")   ){
            item.setCompanyName(jsonObject.get("companyName").toString());
        }
        if(jsonObject.containsKey("storeId")   ){
            item.setStoreId(Integer.valueOf(jsonObject.get("storeId").toString()));
        }
        if(jsonObject.containsKey("storeName")   ){
            item.setStoreName(jsonObject.get("storeName").toString());
        }
        if(jsonObject.containsKey("companyContact")   ){
            item.setCompanyContact(jsonObject.get("companyContact").toString());
        }
        if(jsonObject.containsKey("companyPhone")   ){
            item.setCompanyPhone(jsonObject.get("companyPhone").toString());
        }
        if(jsonObject.containsKey("isDelete")   ){
            item.setIsDelete(Integer.valueOf(jsonObject.get("isDelete").toString()));
        }
            item.setCreateTime(new Date());
        if(jsonObject.containsKey("modifiedTime")   ){
            item.setModifiedTime(Tools.convertStringToDate(jsonObject.get("modifiedTime").toString(), "yyyy-MM-dd HH:mm:ss"));
        }
             tSpaceKeeperCompanyService.create(item);
             lists.add(tSpaceKeeperCompanyService.get(Integer.valueOf(id)));

             });
        return lists;
     }

    @ApiOperation(value = "批量删除'TSpaceKeeperCompany'表中一条信息", notes = "通过post方法请求，传入表中字段的对应信息，创建一条数据。并返回给View层")
        @RequestMapping(value = "/t_space_keeper_companies/delete/batch",
                method = RequestMethod.POST,
                produces = "application/json;charset=UTF-8")
        @ResponseBody
        public Object deletesTSpaceKeeperCompany(
                HttpServletRequest request,
                @RequestHeader(value = "X-Auth-Token", required = false) String token,
                @RequestParam(value = "ids", required = true) String ids
        ) {

            JSONArray jsonArray = JSON.parseArray(ids);
            jsonArray.stream().forEach(id->{

                 TSpaceKeeperCompany item = tSpaceKeeperCompanyService.get(Integer.valueOf(id.toString()));
                if (null != item) {
                    tSpaceKeeperCompanyService.delete(Integer.valueOf(id.toString()));
                }

            });
            return Resp.succ("delete success");
        }
}
