package com.haomostudio.so.controller;

import com.haomostudio.so.common.Resp;
import com.haomostudio.so.po.TStore;
import com.haomostudio.so.service.TStoreService;
import com.haomostudio.so.service.HmUtils.Tools;
import com.alibaba.fastjson.*;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.lang.reflect.InvocationTargetException;
import java.text.SimpleDateFormat;
import java.util.*;

/**
 * Created by hxg on 2016/10/06.
 */
@Api(description = "TStore")
@Controller
public class TStoreController {

    @Autowired
    TStoreService tStoreService;

    @Autowired
    HttpServletResponse response;

    @ApiOperation(value = "创建'TStore'表中一条信息", notes = "通过post方法请求，传入表中字段的对应信息，创建一条数据。并返回给View层")
    @RequestMapping(value = "/t_stores/new",
                    method = RequestMethod.POST,
                    produces = "application/json;charset=UTF-8")
    @ResponseBody
    public Object createTStore(
            HttpServletRequest request,
            @RequestHeader(value = "X-Auth-Token") String token,
            @RequestParam(value = "storeName", required = false) String storeName,
            @RequestParam(value = "storeCode", required = false) String storeCode,
            @RequestParam(value = "spaceId", required = false) Integer spaceId,
            @RequestParam(value = "provinceCode", required = false) String provinceCode,
            @RequestParam(value = "provinceName", required = false) String provinceName,
            @RequestParam(value = "cityCode", required = false) String cityCode,
            @RequestParam(value = "cityName", required = false) String cityName,
            @RequestParam(value = "districtCode", required = false) String districtCode,
            @RequestParam(value = "districtName", required = false) String districtName,
            @RequestParam(value = "address", required = false) String address,
            @RequestParam(value = "status", required = false) Integer status,
            @RequestParam(value = "latitude", required = false) Double latitude,
            @RequestParam(value = "longitude", required = false) Double longitude,
            @RequestParam(value = "contactName", required = false) String contactName,
            @RequestParam(value = "contactTel", required = false) String contactTel,
            @RequestParam(value = "created", required = false) String created,
            @RequestParam(value = "createdAdminUserId", required = false) Integer createdAdminUserId,
            @RequestParam(value = "updated", required = false) String updated,
            @RequestParam(value = "updatedAdminUserId", required = false) Integer updatedAdminUserId,
            @RequestParam(value = "storeIntroduction", required = false) String storeIntroduction,
            @RequestParam(value = "trafficGuide", required = false) String trafficGuide,
            @RequestParam(value = "countryId", required = false) Integer countryId,
            @RequestParam(value = "countryName", required = false) String countryName,
            @RequestParam(value = "wgs84Latitude", required = false) Double wgs84Latitude,
            @RequestParam(value = "wgs84Longitude", required = false) Double wgs84Longitude,
            @RequestParam(value = "gcj02Latitude", required = false) Double gcj02Latitude,
            @RequestParam(value = "gcj02Longitude", required = false) Double gcj02Longitude,
            @RequestParam(value = "bd09Latitude", required = false) Double bd09Latitude,
            @RequestParam(value = "bd09Longitude", required = false) Double bd09Longitude
    ) {
        TStore item = new TStore();
        String id = Tools.getUUID();
        item.setId(Integer.valueOf(id));
        if( storeName != null ){
            item.setStoreName(storeName);
        }
        if( storeCode != null ){
            item.setStoreCode(storeCode);
        }
        if( spaceId != null ){
            item.setSpaceId(spaceId);
        }
        if( provinceCode != null ){
            item.setProvinceCode(provinceCode);
        }
        if( provinceName != null ){
            item.setProvinceName(provinceName);
        }
        if( cityCode != null ){
            item.setCityCode(cityCode);
        }
        if( cityName != null ){
            item.setCityName(cityName);
        }
        if( districtCode != null ){
            item.setDistrictCode(districtCode);
        }
        if( districtName != null ){
            item.setDistrictName(districtName);
        }
        if( address != null ){
            item.setAddress(address);
        }
        if( status != null ){
            item.setStatus(status);
        }
        if( latitude != null ){
            item.setLatitude(latitude);
        }
        if( longitude != null ){
            item.setLongitude(longitude);
        }
        if( contactName != null ){
            item.setContactName(contactName);
        }
        if( contactTel != null ){
            item.setContactTel(contactTel);
        }
        if( created != null ){
            item.setCreated(Tools.convertStringToDate(created, "yyyy-MM-dd HH:mm:ss"));
        }
        if( createdAdminUserId != null ){
            item.setCreatedAdminUserId(createdAdminUserId);
        }
        if( updated != null ){
            item.setUpdated(Tools.convertStringToDate(updated, "yyyy-MM-dd HH:mm:ss"));
        }
        if( updatedAdminUserId != null ){
            item.setUpdatedAdminUserId(updatedAdminUserId);
        }
        if( storeIntroduction != null ){
            item.setStoreIntroduction(storeIntroduction);
        }
        if( trafficGuide != null ){
            item.setTrafficGuide(trafficGuide);
        }
        if( countryId != null ){
            item.setCountryId(countryId);
        }
        if( countryName != null ){
            item.setCountryName(countryName);
        }
        if( wgs84Latitude != null ){
            item.setWgs84Latitude(wgs84Latitude);
        }
        if( wgs84Longitude != null ){
            item.setWgs84Longitude(wgs84Longitude);
        }
        if( gcj02Latitude != null ){
            item.setGcj02Latitude(gcj02Latitude);
        }
        if( gcj02Longitude != null ){
            item.setGcj02Longitude(gcj02Longitude);
        }
        if( bd09Latitude != null ){
            item.setBd09Latitude(bd09Latitude);
        }
        if( bd09Longitude != null ){
            item.setBd09Longitude(bd09Longitude);
        }
        tStoreService.create(item);

        //若request param为null，但字段定义有默认值，则需从数据库中返回结果
        return tStoreService.get(Integer.valueOf(id));
        //return item;
    }

    @ApiOperation(value = "删除'TStore'表中的某条记录", notes = "根据url传入的数据id，删除整条记录。")
    @RequestMapping(value = "/t_stores/{t_store_id}/delete",
                    method = RequestMethod.POST,
                    produces = "application/json;charset=UTF-8")
    @ResponseBody
    public Object deleteTStore(
            @RequestHeader(value = "X-Auth-Token") String token,
            @PathVariable(value = "t_store_id") Integer id
    ) {
        TStore item = tStoreService.get(id);
        if (null == item) {
            response.setStatus(404);
            return Resp.fail("the asset to be deleted doesn't exist");
        }

        tStoreService.delete(id);
        return Resp.succ("delete success");
    }

    @ApiOperation(value = "修改'TStore'表中的某条记录", notes = "根据url传入的数据id，确定修改表中的某条记录，传入表中字段要修改的信息，不传代表不修改。并返回给View层")
    @RequestMapping(value = "/t_stores/{t_store_id}/edit",
                    method = RequestMethod.POST,
                    produces = "application/json;charset=UTF-8")
    @ResponseBody
    public Object editTStore(
            HttpServletRequest request,
            @RequestHeader(value = "X-Auth-Token") String token,
            @PathVariable(value = "t_store_id") Integer id,
            @RequestParam(value = "storeName", required = false) String storeName,
            @RequestParam(value = "storeCode", required = false) String storeCode,
            @RequestParam(value = "spaceId", required = false) Integer spaceId,
            @RequestParam(value = "provinceCode", required = false) String provinceCode,
            @RequestParam(value = "provinceName", required = false) String provinceName,
            @RequestParam(value = "cityCode", required = false) String cityCode,
            @RequestParam(value = "cityName", required = false) String cityName,
            @RequestParam(value = "districtCode", required = false) String districtCode,
            @RequestParam(value = "districtName", required = false) String districtName,
            @RequestParam(value = "address", required = false) String address,
            @RequestParam(value = "status", required = false) Integer status,
            @RequestParam(value = "latitude", required = false) Double latitude,
            @RequestParam(value = "longitude", required = false) Double longitude,
            @RequestParam(value = "contactName", required = false) String contactName,
            @RequestParam(value = "contactTel", required = false) String contactTel,
            @RequestParam(value = "created", required = false) String created,
            @RequestParam(value = "createdAdminUserId", required = false) Integer createdAdminUserId,
            @RequestParam(value = "updated", required = false) String updated,
            @RequestParam(value = "updatedAdminUserId", required = false) Integer updatedAdminUserId,
            @RequestParam(value = "storeIntroduction", required = false) String storeIntroduction,
            @RequestParam(value = "trafficGuide", required = false) String trafficGuide,
            @RequestParam(value = "countryId", required = false) Integer countryId,
            @RequestParam(value = "countryName", required = false) String countryName,
            @RequestParam(value = "wgs84Latitude", required = false) Double wgs84Latitude,
            @RequestParam(value = "wgs84Longitude", required = false) Double wgs84Longitude,
            @RequestParam(value = "gcj02Latitude", required = false) Double gcj02Latitude,
            @RequestParam(value = "gcj02Longitude", required = false) Double gcj02Longitude,
            @RequestParam(value = "bd09Latitude", required = false) Double bd09Latitude,
            @RequestParam(value = "bd09Longitude", required = false) Double bd09Longitude
    ) {
        TStore item = tStoreService.get(id);
        if (null == item) {
            response.setStatus(404);
            return Resp.fail("the asset to be edited doesn't exist");
        }

        if( storeName != null ){
            item.setStoreName(storeName);
        }
        if( storeCode != null ){
            item.setStoreCode(storeCode);
        }
        if( spaceId != null ){
            item.setSpaceId(spaceId);
        }
        if( provinceCode != null ){
            item.setProvinceCode(provinceCode);
        }
        if( provinceName != null ){
            item.setProvinceName(provinceName);
        }
        if( cityCode != null ){
            item.setCityCode(cityCode);
        }
        if( cityName != null ){
            item.setCityName(cityName);
        }
        if( districtCode != null ){
            item.setDistrictCode(districtCode);
        }
        if( districtName != null ){
            item.setDistrictName(districtName);
        }
        if( address != null ){
            item.setAddress(address);
        }
        if( status != null ){
            item.setStatus(status);
        }
        if( latitude != null ){
            item.setLatitude(latitude);
        }
        if( longitude != null ){
            item.setLongitude(longitude);
        }
        if( contactName != null ){
            item.setContactName(contactName);
        }
        if( contactTel != null ){
            item.setContactTel(contactTel);
        }
        if( created != null ){
            item.setCreated(Tools.convertStringToDate(created, "yyyy-MM-dd HH:mm:ss"));
        }
        if( createdAdminUserId != null ){
            item.setCreatedAdminUserId(createdAdminUserId);
        }
        if( updated != null ){
            item.setUpdated(Tools.convertStringToDate(updated, "yyyy-MM-dd HH:mm:ss"));
        }
        if( updatedAdminUserId != null ){
            item.setUpdatedAdminUserId(updatedAdminUserId);
        }
        if( storeIntroduction != null ){
            item.setStoreIntroduction(storeIntroduction);
        }
        if( trafficGuide != null ){
            item.setTrafficGuide(trafficGuide);
        }
        if( countryId != null ){
            item.setCountryId(countryId);
        }
        if( countryName != null ){
            item.setCountryName(countryName);
        }
        if( wgs84Latitude != null ){
            item.setWgs84Latitude(wgs84Latitude);
        }
        if( wgs84Longitude != null ){
            item.setWgs84Longitude(wgs84Longitude);
        }
        if( gcj02Latitude != null ){
            item.setGcj02Latitude(gcj02Latitude);
        }
        if( gcj02Longitude != null ){
            item.setGcj02Longitude(gcj02Longitude);
        }
        if( bd09Latitude != null ){
            item.setBd09Latitude(bd09Latitude);
        }
        if( bd09Longitude != null ){
            item.setBd09Longitude(bd09Longitude);
        }
        tStoreService.update(item);

        return tStoreService.get(id);
    }

    @ApiOperation(value = "查询'TStore'表中的某条记录", notes = "根据url传入的数据id，查询对应的一条数据。")
    @RequestMapping(value = "/t_stores/{t_store_id}",
                    method = {RequestMethod.GET, RequestMethod.DELETE, RequestMethod.PUT},
                    produces = "application/json;charset=UTF-8")
    @ResponseBody
    public Object getTStore(
            HttpServletRequest request,
            @RequestHeader(value = "X-Auth-Token") String token,
            @PathVariable(value = "t_store_id") Integer id,
            @RequestParam(value = "storeName", required = false) String storeName,
            @RequestParam(value = "storeCode", required = false) String storeCode,
            @RequestParam(value = "spaceId", required = false) Integer spaceId,
            @RequestParam(value = "provinceCode", required = false) String provinceCode,
            @RequestParam(value = "provinceName", required = false) String provinceName,
            @RequestParam(value = "cityCode", required = false) String cityCode,
            @RequestParam(value = "cityName", required = false) String cityName,
            @RequestParam(value = "districtCode", required = false) String districtCode,
            @RequestParam(value = "districtName", required = false) String districtName,
            @RequestParam(value = "address", required = false) String address,
            @RequestParam(value = "status", required = false) Integer status,
            @RequestParam(value = "latitude", required = false) Double latitude,
            @RequestParam(value = "longitude", required = false) Double longitude,
            @RequestParam(value = "contactName", required = false) String contactName,
            @RequestParam(value = "contactTel", required = false) String contactTel,
            @RequestParam(value = "created", required = false) String created,
            @RequestParam(value = "createdAdminUserId", required = false) Integer createdAdminUserId,
            @RequestParam(value = "updated", required = false) String updated,
            @RequestParam(value = "updatedAdminUserId", required = false) Integer updatedAdminUserId,
            @RequestParam(value = "storeIntroduction", required = false) String storeIntroduction,
            @RequestParam(value = "trafficGuide", required = false) String trafficGuide,
            @RequestParam(value = "countryId", required = false) Integer countryId,
            @RequestParam(value = "countryName", required = false) String countryName,
            @RequestParam(value = "wgs84Latitude", required = false) Double wgs84Latitude,
            @RequestParam(value = "wgs84Longitude", required = false) Double wgs84Longitude,
            @RequestParam(value = "gcj02Latitude", required = false) Double gcj02Latitude,
            @RequestParam(value = "gcj02Longitude", required = false) Double gcj02Longitude,
            @RequestParam(value = "bd09Latitude", required = false) Double bd09Latitude,
            @RequestParam(value = "bd09Longitude", required = false) Double bd09Longitude
    ) {
        if(request.getMethod().equals("GET")){
            TStore item = tStoreService.get(id);
            if (null == item) {
                response.setStatus(404);
                return Resp.fail("the asset to be edited doesn't exist");
            }

            return item;
        }
        else if(request.getMethod().equals("PUT")){
            TStore item = tStoreService.get(id);
            if (null == item) {
                response.setStatus(404);
                return Resp.fail("the asset to be edited doesn't exist");
            }

            if( storeName != null ){
                item.setStoreName(storeName);
            }
            if( storeCode != null ){
                item.setStoreCode(storeCode);
            }
            if( spaceId != null ){
                item.setSpaceId(spaceId);
            }
            if( provinceCode != null ){
                item.setProvinceCode(provinceCode);
            }
            if( provinceName != null ){
                item.setProvinceName(provinceName);
            }
            if( cityCode != null ){
                item.setCityCode(cityCode);
            }
            if( cityName != null ){
                item.setCityName(cityName);
            }
            if( districtCode != null ){
                item.setDistrictCode(districtCode);
            }
            if( districtName != null ){
                item.setDistrictName(districtName);
            }
            if( address != null ){
                item.setAddress(address);
            }
            if( status != null ){
                item.setStatus(status);
            }
            if( latitude != null ){
                item.setLatitude(latitude);
            }
            if( longitude != null ){
                item.setLongitude(longitude);
            }
            if( contactName != null ){
                item.setContactName(contactName);
            }
            if( contactTel != null ){
                item.setContactTel(contactTel);
            }
            if( created != null ){
                item.setCreated(Tools.convertStringToDate(created, "yyyy-MM-dd HH:mm:ss"));
            }
            if( createdAdminUserId != null ){
                item.setCreatedAdminUserId(createdAdminUserId);
            }
            if( updated != null ){
                item.setUpdated(Tools.convertStringToDate(updated, "yyyy-MM-dd HH:mm:ss"));
            }
            if( updatedAdminUserId != null ){
                item.setUpdatedAdminUserId(updatedAdminUserId);
            }
            if( storeIntroduction != null ){
                item.setStoreIntroduction(storeIntroduction);
            }
            if( trafficGuide != null ){
                item.setTrafficGuide(trafficGuide);
            }
            if( countryId != null ){
                item.setCountryId(countryId);
            }
            if( countryName != null ){
                item.setCountryName(countryName);
            }
            if( wgs84Latitude != null ){
                item.setWgs84Latitude(wgs84Latitude);
            }
            if( wgs84Longitude != null ){
                item.setWgs84Longitude(wgs84Longitude);
            }
            if( gcj02Latitude != null ){
                item.setGcj02Latitude(gcj02Latitude);
            }
            if( gcj02Longitude != null ){
                item.setGcj02Longitude(gcj02Longitude);
            }
            if( bd09Latitude != null ){
                item.setBd09Latitude(bd09Latitude);
            }
            if( bd09Longitude != null ){
                item.setBd09Longitude(bd09Longitude);
            }
            tStoreService.update(item);

            return tStoreService.get(id);
        }
        else if(request.getMethod().equals("DELETE")){
            TStore item = tStoreService.get(id);
            if (null == item) {
                response.setStatus(404);
                return Resp.fail("the asset to be deleted doesn't exist");
            }

            tStoreService.delete(id);
            return Resp.succ("delete success");
        }
        return Resp.fail("Unknown http method");
    }

    @ApiOperation(value = "查询'TStore'表中的多条记录或者新增某条记录", notes = "get传参：根据url传入的filters（过滤条件），查询对应的多条数据。数据数量取决于pageNo和pageSize；数据的先后顺序取决于sortItem，sortOrder；   post请求：新增某条记录，传入表字段对应的值")
    @RequestMapping(value = "/t_stores",
                    method = { RequestMethod.GET, RequestMethod.POST },
                    produces = "application/json;charset=UTF-8")
    @ResponseBody
    public Object getTStores(
            HttpServletRequest request,
            @RequestHeader(value = "X-Auth-Token", required = false) String token,
            @RequestParam(value = "pageNo", required = false) Integer pageNo,
            @RequestParam(value = "pageSize", required = false) Integer pageSize,
            @RequestParam(value = "sortItem", required = false) String sortItem,
            @RequestParam(value = "sortOrder", required = false) String sortOrder,
            @RequestParam(value = "filters", required = false) String filters,
            @RequestParam(value = "includes", required = false) String includes,
            @RequestParam(value = "refers", required = false) String refers,
            @RequestParam(value = "relates", required = false) String relates
    ) {
        if(pageNo == null){
            pageNo = 1;
        }
        if(pageSize == null){
            pageSize = 10;
        }
        if(sortItem == null){
            sortItem = "id";
        }
        if(sortOrder == null){
            sortOrder = "asc";
        }
        if(filters == null){
            filters = "{}";
        }

        Long total = tStoreService.countListWithPagingAndFilter(filters);
        response.addHeader("total", String.valueOf(total));

        return tStoreService.getListWithPagingAndFilter(
                        pageNo, pageSize, sortItem, sortOrder, filters, includes, refers, relates);

    }

    @ApiOperation(value = "出入字段数组返回对应字段数据", notes = "get传参：根据url传入的filters（过滤条件），查询对应的多条数据。只返回你传进来的字段对应的数据")
    @RequestMapping(value = "/t_stores/columns",
                    method = { RequestMethod.GET },
                    produces = "application/json;charset=UTF-8")
    @ResponseBody
    public Object getTStoresId(
            HttpServletRequest request,
            @RequestHeader(value = "X-Auth-Token", required = false) String token,
            @RequestParam(value = "filters", required = true) String filters,
            @RequestParam(value = "columns", required = true) String columns,
            @RequestParam(value = "sortOrder", required = false) String sortOrder,
            @RequestParam(value = "sortItem", required = false) String sortItem,
            @RequestParam(value = "pageNo", required = false) Integer pageNo,
            @RequestParam(value = "pageSize", required = false) Integer pageSize
    ) {
        if(pageNo == null){
            pageNo = 1;
        }
        if(pageSize == null){
            pageSize = 10;
        }
        if(sortOrder==null){
            sortOrder = "asc";
        }
        if(sortItem==null){
            sortItem = "id";
        }
        JSONArray jsonArray = JSON.parseArray(columns);
        List<Map<String,Object>> lists  = new ArrayList<>();
        List<TStore> list = tStoreService.getListWithPagingAndFilter(
                pageNo, pageSize, sortItem, sortOrder, filters);

        //反射调取get方法
        Class clz = TStore.class;
        list.stream().forEach(lot->{
            Map<String,Object> map = new HashMap<>();
            for (Object j : jsonArray){
                String s = (String) j;
                s = s.replaceFirst(s.substring(0,1),s.substring(0,1).toUpperCase());
                try {
                    if (clz.getMethod("get"+s).invoke(lot) !=null){
                        map.put((String) j,clz.getMethod("get"+s).invoke(lot));
                    }
                } catch (NoSuchMethodException e) {
                    e.printStackTrace();
                } catch (InvocationTargetException e) {
                    e.printStackTrace();
                } catch (IllegalAccessException e) {
                    e.printStackTrace();
                }
            }
            lists.add(map);
        });

        return lists;
     }



    @ApiOperation(value = "批量创建'TStore'表中一条信息", notes = "通过post方法请求，传入表中字段的对应信息，创建一条数据。并返回给View层")
    @RequestMapping(value = "/t_stores/create//batch",
               method = RequestMethod.POST,
               produces = "application/json;charset=UTF-8")
    @ResponseBody
    public Object createsTStores(
             HttpServletRequest request,
             @RequestHeader(value = "X-Auth-Token", required = false) String token,
             @RequestParam(value = "params", required = false) String params
    ) {

             JSONArray jsonArray = JSON.parseArray(params);
             List<TStore> lists  = new ArrayList<>();

             jsonArray.stream().forEach((Object object) -> {

             JSONObject jsonObject = JSONObject.parseObject(object.toString());

             TStore item = new TStore();
             String id = Tools.getUUID();
                         item.setId(Integer.valueOf(id));
             if(jsonObject.containsKey("storeName")   ){
            item.setStoreName(jsonObject.get("storeName").toString());
        }
        if(jsonObject.containsKey("storeCode")   ){
            item.setStoreCode(jsonObject.get("storeCode").toString());
        }
        if(jsonObject.containsKey("spaceId")   ){
            item.setSpaceId(Integer.valueOf(jsonObject.get("spaceId").toString()));
        }
        if(jsonObject.containsKey("provinceCode")   ){
            item.setProvinceCode(jsonObject.get("provinceCode").toString());
        }
        if(jsonObject.containsKey("provinceName")   ){
            item.setProvinceName(jsonObject.get("provinceName").toString());
        }
        if(jsonObject.containsKey("cityCode")   ){
            item.setCityCode(jsonObject.get("cityCode").toString());
        }
        if(jsonObject.containsKey("cityName")   ){
            item.setCityName(jsonObject.get("cityName").toString());
        }
        if(jsonObject.containsKey("districtCode")   ){
            item.setDistrictCode(jsonObject.get("districtCode").toString());
        }
        if(jsonObject.containsKey("districtName")   ){
            item.setDistrictName(jsonObject.get("districtName").toString());
        }
        if(jsonObject.containsKey("address")   ){
            item.setAddress(jsonObject.get("address").toString());
        }
        if(jsonObject.containsKey("status")   ){
            item.setStatus(Integer.valueOf(jsonObject.get("status").toString()));
        }
        if(jsonObject.containsKey("latitude")   ){
            item.setLatitude(new Double(jsonObject.get("latitude").toString()));
        }
        if(jsonObject.containsKey("longitude")   ){
            item.setLongitude(new Double(jsonObject.get("longitude").toString()));
        }
        if(jsonObject.containsKey("contactName")   ){
            item.setContactName(jsonObject.get("contactName").toString());
        }
        if(jsonObject.containsKey("contactTel")   ){
            item.setContactTel(jsonObject.get("contactTel").toString());
        }
        if(jsonObject.containsKey("created")   ){
            item.setCreated(Tools.convertStringToDate(jsonObject.get("created").toString(), "yyyy-MM-dd HH:mm:ss"));
        }
        if(jsonObject.containsKey("createdAdminUserId")   ){
            item.setCreatedAdminUserId(Integer.valueOf(jsonObject.get("createdAdminUserId").toString()));
        }
        if(jsonObject.containsKey("updated")   ){
            item.setUpdated(Tools.convertStringToDate(jsonObject.get("updated").toString(), "yyyy-MM-dd HH:mm:ss"));
        }
        if(jsonObject.containsKey("updatedAdminUserId")   ){
            item.setUpdatedAdminUserId(Integer.valueOf(jsonObject.get("updatedAdminUserId").toString()));
        }
        if(jsonObject.containsKey("storeIntroduction")   ){
            item.setStoreIntroduction(jsonObject.get("storeIntroduction").toString());
        }
        if(jsonObject.containsKey("trafficGuide")   ){
            item.setTrafficGuide(jsonObject.get("trafficGuide").toString());
        }
        if(jsonObject.containsKey("countryId")   ){
            item.setCountryId(Integer.valueOf(jsonObject.get("countryId").toString()));
        }
        if(jsonObject.containsKey("countryName")   ){
            item.setCountryName(jsonObject.get("countryName").toString());
        }
        if(jsonObject.containsKey("wgs84Latitude")   ){
            item.setWgs84Latitude(new Double(jsonObject.get("wgs84Latitude").toString()));
        }
        if(jsonObject.containsKey("wgs84Longitude")   ){
            item.setWgs84Longitude(new Double(jsonObject.get("wgs84Longitude").toString()));
        }
        if(jsonObject.containsKey("gcj02Latitude")   ){
            item.setGcj02Latitude(new Double(jsonObject.get("gcj02Latitude").toString()));
        }
        if(jsonObject.containsKey("gcj02Longitude")   ){
            item.setGcj02Longitude(new Double(jsonObject.get("gcj02Longitude").toString()));
        }
        if(jsonObject.containsKey("bd09Latitude")   ){
            item.setBd09Latitude(new Double(jsonObject.get("bd09Latitude").toString()));
        }
        if(jsonObject.containsKey("bd09Longitude")   ){
            item.setBd09Longitude(new Double(jsonObject.get("bd09Longitude").toString()));
        }
             tStoreService.create(item);
             lists.add(tStoreService.get(Integer.valueOf(id)));

             });
        return lists;
     }

    @ApiOperation(value = "批量删除'TStore'表中一条信息", notes = "通过post方法请求，传入表中字段的对应信息，创建一条数据。并返回给View层")
        @RequestMapping(value = "/t_stores/delete/batch",
                method = RequestMethod.POST,
                produces = "application/json;charset=UTF-8")
        @ResponseBody
        public Object deletesTStore(
                HttpServletRequest request,
                @RequestHeader(value = "X-Auth-Token", required = false) String token,
                @RequestParam(value = "ids", required = true) String ids
        ) {

            JSONArray jsonArray = JSON.parseArray(ids);
            jsonArray.stream().forEach(id->{

                 TStore item = tStoreService.get(Integer.valueOf(id.toString()));
                if (null != item) {
                    tStoreService.delete(Integer.valueOf(id.toString()));
                }

            });
            return Resp.succ("delete success");
        }
}
