package com.haomostudio.so.controller;

import com.haomostudio.so.common.Resp;
import com.haomostudio.so.po.TValueAddServiceOrder;
import com.haomostudio.so.service.TValueAddServiceOrderService;
import com.haomostudio.so.service.HmUtils.Tools;
import com.alibaba.fastjson.*;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.lang.reflect.InvocationTargetException;
import java.text.SimpleDateFormat;
import java.util.*;

/**
 * Created by hxg on 2016/10/06.
 */
@Api(description = "TValueAddServiceOrder")
@Controller
public class TValueAddServiceOrderController {

    @Autowired
    TValueAddServiceOrderService tValueAddServiceOrderService;

    @Autowired
    HttpServletResponse response;

    @ApiOperation(value = "创建'TValueAddServiceOrder'表中一条信息", notes = "通过post方法请求，传入表中字段的对应信息，创建一条数据。并返回给View层")
    @RequestMapping(value = "/t_value_add_service_orders/new",
                    method = RequestMethod.POST,
                    produces = "application/json;charset=UTF-8")
    @ResponseBody
    public Object createTValueAddServiceOrder(
            HttpServletRequest request,
            @RequestHeader(value = "X-Auth-Token") String token,
            @RequestParam(value = "orderNum", required = false) String orderNum,
            @RequestParam(value = "userId", required = false) Integer userId,
            @RequestParam(value = "spaceId", required = false) Integer spaceId,
            @RequestParam(value = "serviceId", required = false) Integer serviceId,
            @RequestParam(value = "serviceName", required = false) String serviceName,
            @RequestParam(value = "providerId", required = false) Integer providerId,
            @RequestParam(value = "providerName", required = false) String providerName,
            @RequestParam(value = "contact", required = false) String contact,
            @RequestParam(value = "phone", required = false) String phone,
            @RequestParam(value = "description", required = false) String description,
            @RequestParam(value = "note", required = false) String note,
            @RequestParam(value = "orderStatus", required = false) Integer orderStatus,
            @RequestParam(value = "createDate", required = false) String createDate,
            @RequestParam(value = "lastModifyDate", required = false) String lastModifyDate,
            @RequestParam(value = "acceptTime", required = false) String acceptTime
    ) {
        TValueAddServiceOrder item = new TValueAddServiceOrder();
        String id = Tools.getUUID();
        item.setId(Integer.valueOf(id));
        if( orderNum != null ){
            item.setOrderNum(orderNum);
        }
        if( userId != null ){
            item.setUserId(userId);
        }
        if( spaceId != null ){
            item.setSpaceId(spaceId);
        }
        if( serviceId != null ){
            item.setServiceId(serviceId);
        }
        if( serviceName != null ){
            item.setServiceName(serviceName);
        }
        if( providerId != null ){
            item.setProviderId(providerId);
        }
        if( providerName != null ){
            item.setProviderName(providerName);
        }
        if( contact != null ){
            item.setContact(contact);
        }
        if( phone != null ){
            item.setPhone(phone);
        }
        if( description != null ){
            item.setDescription(description);
        }
        if( note != null ){
            item.setNote(note);
        }
        if( orderStatus != null ){
            item.setOrderStatus(orderStatus);
        }
        if( createDate != null ){
            item.setCreateDate(Tools.convertStringToDate(createDate, "yyyy-MM-dd HH:mm:ss"));
        }
        if( lastModifyDate != null ){
            item.setLastModifyDate(Tools.convertStringToDate(lastModifyDate, "yyyy-MM-dd HH:mm:ss"));
        }
        if( acceptTime != null ){
            item.setAcceptTime(Tools.convertStringToDate(acceptTime, "yyyy-MM-dd HH:mm:ss"));
        }
        tValueAddServiceOrderService.create(item);

        //若request param为null，但字段定义有默认值，则需从数据库中返回结果
        return tValueAddServiceOrderService.get(Integer.valueOf(id));
        //return item;
    }

    @ApiOperation(value = "删除'TValueAddServiceOrder'表中的某条记录", notes = "根据url传入的数据id，删除整条记录。")
    @RequestMapping(value = "/t_value_add_service_orders/{t_value_add_service_order_id}/delete",
                    method = RequestMethod.POST,
                    produces = "application/json;charset=UTF-8")
    @ResponseBody
    public Object deleteTValueAddServiceOrder(
            @RequestHeader(value = "X-Auth-Token") String token,
            @PathVariable(value = "t_value_add_service_order_id") Integer id
    ) {
        TValueAddServiceOrder item = tValueAddServiceOrderService.get(id);
        if (null == item) {
            response.setStatus(404);
            return Resp.fail("the asset to be deleted doesn't exist");
        }

        tValueAddServiceOrderService.delete(id);
        return Resp.succ("delete success");
    }

    @ApiOperation(value = "修改'TValueAddServiceOrder'表中的某条记录", notes = "根据url传入的数据id，确定修改表中的某条记录，传入表中字段要修改的信息，不传代表不修改。并返回给View层")
    @RequestMapping(value = "/t_value_add_service_orders/{t_value_add_service_order_id}/edit",
                    method = RequestMethod.POST,
                    produces = "application/json;charset=UTF-8")
    @ResponseBody
    public Object editTValueAddServiceOrder(
            HttpServletRequest request,
            @RequestHeader(value = "X-Auth-Token") String token,
            @PathVariable(value = "t_value_add_service_order_id") Integer id,
            @RequestParam(value = "orderNum", required = false) String orderNum,
            @RequestParam(value = "userId", required = false) Integer userId,
            @RequestParam(value = "spaceId", required = false) Integer spaceId,
            @RequestParam(value = "serviceId", required = false) Integer serviceId,
            @RequestParam(value = "serviceName", required = false) String serviceName,
            @RequestParam(value = "providerId", required = false) Integer providerId,
            @RequestParam(value = "providerName", required = false) String providerName,
            @RequestParam(value = "contact", required = false) String contact,
            @RequestParam(value = "phone", required = false) String phone,
            @RequestParam(value = "description", required = false) String description,
            @RequestParam(value = "note", required = false) String note,
            @RequestParam(value = "orderStatus", required = false) Integer orderStatus,
            @RequestParam(value = "createDate", required = false) String createDate,
            @RequestParam(value = "lastModifyDate", required = false) String lastModifyDate,
            @RequestParam(value = "acceptTime", required = false) String acceptTime
    ) {
        TValueAddServiceOrder item = tValueAddServiceOrderService.get(id);
        if (null == item) {
            response.setStatus(404);
            return Resp.fail("the asset to be edited doesn't exist");
        }

        if( orderNum != null ){
            item.setOrderNum(orderNum);
        }
        if( userId != null ){
            item.setUserId(userId);
        }
        if( spaceId != null ){
            item.setSpaceId(spaceId);
        }
        if( serviceId != null ){
            item.setServiceId(serviceId);
        }
        if( serviceName != null ){
            item.setServiceName(serviceName);
        }
        if( providerId != null ){
            item.setProviderId(providerId);
        }
        if( providerName != null ){
            item.setProviderName(providerName);
        }
        if( contact != null ){
            item.setContact(contact);
        }
        if( phone != null ){
            item.setPhone(phone);
        }
        if( description != null ){
            item.setDescription(description);
        }
        if( note != null ){
            item.setNote(note);
        }
        if( orderStatus != null ){
            item.setOrderStatus(orderStatus);
        }
        if( createDate != null ){
            item.setCreateDate(Tools.convertStringToDate(createDate, "yyyy-MM-dd HH:mm:ss"));
        }
        if( lastModifyDate != null ){
            item.setLastModifyDate(Tools.convertStringToDate(lastModifyDate, "yyyy-MM-dd HH:mm:ss"));
        }
        if( acceptTime != null ){
            item.setAcceptTime(Tools.convertStringToDate(acceptTime, "yyyy-MM-dd HH:mm:ss"));
        }
        tValueAddServiceOrderService.update(item);

        return tValueAddServiceOrderService.get(id);
    }

    @ApiOperation(value = "查询'TValueAddServiceOrder'表中的某条记录", notes = "根据url传入的数据id，查询对应的一条数据。")
    @RequestMapping(value = "/t_value_add_service_orders/{t_value_add_service_order_id}",
                    method = {RequestMethod.GET, RequestMethod.DELETE, RequestMethod.PUT},
                    produces = "application/json;charset=UTF-8")
    @ResponseBody
    public Object getTValueAddServiceOrder(
            HttpServletRequest request,
            @RequestHeader(value = "X-Auth-Token") String token,
            @PathVariable(value = "t_value_add_service_order_id") Integer id,
            @RequestParam(value = "orderNum", required = false) String orderNum,
            @RequestParam(value = "userId", required = false) Integer userId,
            @RequestParam(value = "spaceId", required = false) Integer spaceId,
            @RequestParam(value = "serviceId", required = false) Integer serviceId,
            @RequestParam(value = "serviceName", required = false) String serviceName,
            @RequestParam(value = "providerId", required = false) Integer providerId,
            @RequestParam(value = "providerName", required = false) String providerName,
            @RequestParam(value = "contact", required = false) String contact,
            @RequestParam(value = "phone", required = false) String phone,
            @RequestParam(value = "description", required = false) String description,
            @RequestParam(value = "note", required = false) String note,
            @RequestParam(value = "orderStatus", required = false) Integer orderStatus,
            @RequestParam(value = "createDate", required = false) String createDate,
            @RequestParam(value = "lastModifyDate", required = false) String lastModifyDate,
            @RequestParam(value = "acceptTime", required = false) String acceptTime
    ) {
        if(request.getMethod().equals("GET")){
            TValueAddServiceOrder item = tValueAddServiceOrderService.get(id);
            if (null == item) {
                response.setStatus(404);
                return Resp.fail("the asset to be edited doesn't exist");
            }

            return item;
        }
        else if(request.getMethod().equals("PUT")){
            TValueAddServiceOrder item = tValueAddServiceOrderService.get(id);
            if (null == item) {
                response.setStatus(404);
                return Resp.fail("the asset to be edited doesn't exist");
            }

            if( orderNum != null ){
                item.setOrderNum(orderNum);
            }
            if( userId != null ){
                item.setUserId(userId);
            }
            if( spaceId != null ){
                item.setSpaceId(spaceId);
            }
            if( serviceId != null ){
                item.setServiceId(serviceId);
            }
            if( serviceName != null ){
                item.setServiceName(serviceName);
            }
            if( providerId != null ){
                item.setProviderId(providerId);
            }
            if( providerName != null ){
                item.setProviderName(providerName);
            }
            if( contact != null ){
                item.setContact(contact);
            }
            if( phone != null ){
                item.setPhone(phone);
            }
            if( description != null ){
                item.setDescription(description);
            }
            if( note != null ){
                item.setNote(note);
            }
            if( orderStatus != null ){
                item.setOrderStatus(orderStatus);
            }
            if( createDate != null ){
                item.setCreateDate(Tools.convertStringToDate(createDate, "yyyy-MM-dd HH:mm:ss"));
            }
            if( lastModifyDate != null ){
                item.setLastModifyDate(Tools.convertStringToDate(lastModifyDate, "yyyy-MM-dd HH:mm:ss"));
            }
            if( acceptTime != null ){
                item.setAcceptTime(Tools.convertStringToDate(acceptTime, "yyyy-MM-dd HH:mm:ss"));
            }
            tValueAddServiceOrderService.update(item);

            return tValueAddServiceOrderService.get(id);
        }
        else if(request.getMethod().equals("DELETE")){
            TValueAddServiceOrder item = tValueAddServiceOrderService.get(id);
            if (null == item) {
                response.setStatus(404);
                return Resp.fail("the asset to be deleted doesn't exist");
            }

            tValueAddServiceOrderService.delete(id);
            return Resp.succ("delete success");
        }
        return Resp.fail("Unknown http method");
    }

    @ApiOperation(value = "查询'TValueAddServiceOrder'表中的多条记录或者新增某条记录", notes = "get传参：根据url传入的filters（过滤条件），查询对应的多条数据。数据数量取决于pageNo和pageSize；数据的先后顺序取决于sortItem，sortOrder；   post请求：新增某条记录，传入表字段对应的值")
    @RequestMapping(value = "/t_value_add_service_orders",
                    method = { RequestMethod.GET, RequestMethod.POST },
                    produces = "application/json;charset=UTF-8")
    @ResponseBody
    public Object getTValueAddServiceOrders(
            HttpServletRequest request,
            @RequestHeader(value = "X-Auth-Token", required = false) String token,
            @RequestParam(value = "pageNo", required = false) Integer pageNo,
            @RequestParam(value = "pageSize", required = false) Integer pageSize,
            @RequestParam(value = "sortItem", required = false) String sortItem,
            @RequestParam(value = "sortOrder", required = false) String sortOrder,
            @RequestParam(value = "filters", required = false) String filters,
            @RequestParam(value = "includes", required = false) String includes,
            @RequestParam(value = "refers", required = false) String refers,
            @RequestParam(value = "relates", required = false) String relates
    ) {
        if(pageNo == null){
            pageNo = 1;
        }
        if(pageSize == null){
            pageSize = 10;
        }
        if(sortItem == null){
            sortItem = "id";
        }
        if(sortOrder == null){
            sortOrder = "asc";
        }
        if(filters == null){
            filters = "{}";
        }

        Long total = tValueAddServiceOrderService.countListWithPagingAndFilter(filters);
        response.addHeader("total", String.valueOf(total));

        return tValueAddServiceOrderService.getListWithPagingAndFilter(
                        pageNo, pageSize, sortItem, sortOrder, filters, includes, refers, relates);

    }

    @ApiOperation(value = "出入字段数组返回对应字段数据", notes = "get传参：根据url传入的filters（过滤条件），查询对应的多条数据。只返回你传进来的字段对应的数据")
    @RequestMapping(value = "/t_value_add_service_orders/columns",
                    method = { RequestMethod.GET },
                    produces = "application/json;charset=UTF-8")
    @ResponseBody
    public Object getTValueAddServiceOrdersId(
            HttpServletRequest request,
            @RequestHeader(value = "X-Auth-Token", required = false) String token,
            @RequestParam(value = "filters", required = true) String filters,
            @RequestParam(value = "columns", required = true) String columns,
            @RequestParam(value = "sortOrder", required = false) String sortOrder,
            @RequestParam(value = "sortItem", required = false) String sortItem,
            @RequestParam(value = "pageNo", required = false) Integer pageNo,
            @RequestParam(value = "pageSize", required = false) Integer pageSize
    ) {
        if(pageNo == null){
            pageNo = 1;
        }
        if(pageSize == null){
            pageSize = 10;
        }
        if(sortOrder==null){
            sortOrder = "asc";
        }
        if(sortItem==null){
            sortItem = "id";
        }
        JSONArray jsonArray = JSON.parseArray(columns);
        List<Map<String,Object>> lists  = new ArrayList<>();
        List<TValueAddServiceOrder> list = tValueAddServiceOrderService.getListWithPagingAndFilter(
                pageNo, pageSize, sortItem, sortOrder, filters);

        //反射调取get方法
        Class clz = TValueAddServiceOrder.class;
        list.stream().forEach(lot->{
            Map<String,Object> map = new HashMap<>();
            for (Object j : jsonArray){
                String s = (String) j;
                s = s.replaceFirst(s.substring(0,1),s.substring(0,1).toUpperCase());
                try {
                    if (clz.getMethod("get"+s).invoke(lot) !=null){
                        map.put((String) j,clz.getMethod("get"+s).invoke(lot));
                    }
                } catch (NoSuchMethodException e) {
                    e.printStackTrace();
                } catch (InvocationTargetException e) {
                    e.printStackTrace();
                } catch (IllegalAccessException e) {
                    e.printStackTrace();
                }
            }
            lists.add(map);
        });

        return lists;
     }



    @ApiOperation(value = "批量创建'TValueAddServiceOrder'表中一条信息", notes = "通过post方法请求，传入表中字段的对应信息，创建一条数据。并返回给View层")
    @RequestMapping(value = "/t_value_add_service_orders/create//batch",
               method = RequestMethod.POST,
               produces = "application/json;charset=UTF-8")
    @ResponseBody
    public Object createsTValueAddServiceOrders(
             HttpServletRequest request,
             @RequestHeader(value = "X-Auth-Token", required = false) String token,
             @RequestParam(value = "params", required = false) String params
    ) {

             JSONArray jsonArray = JSON.parseArray(params);
             List<TValueAddServiceOrder> lists  = new ArrayList<>();

             jsonArray.stream().forEach((Object object) -> {

             JSONObject jsonObject = JSONObject.parseObject(object.toString());

             TValueAddServiceOrder item = new TValueAddServiceOrder();
             String id = Tools.getUUID();
                         item.setId(Integer.valueOf(id));
             if(jsonObject.containsKey("orderNum")   ){
            item.setOrderNum(jsonObject.get("orderNum").toString());
        }
        if(jsonObject.containsKey("userId")   ){
            item.setUserId(Integer.valueOf(jsonObject.get("userId").toString()));
        }
        if(jsonObject.containsKey("spaceId")   ){
            item.setSpaceId(Integer.valueOf(jsonObject.get("spaceId").toString()));
        }
        if(jsonObject.containsKey("serviceId")   ){
            item.setServiceId(Integer.valueOf(jsonObject.get("serviceId").toString()));
        }
        if(jsonObject.containsKey("serviceName")   ){
            item.setServiceName(jsonObject.get("serviceName").toString());
        }
        if(jsonObject.containsKey("providerId")   ){
            item.setProviderId(Integer.valueOf(jsonObject.get("providerId").toString()));
        }
        if(jsonObject.containsKey("providerName")   ){
            item.setProviderName(jsonObject.get("providerName").toString());
        }
        if(jsonObject.containsKey("contact")   ){
            item.setContact(jsonObject.get("contact").toString());
        }
        if(jsonObject.containsKey("phone")   ){
            item.setPhone(jsonObject.get("phone").toString());
        }
        if(jsonObject.containsKey("description")   ){
            item.setDescription(jsonObject.get("description").toString());
        }
        if(jsonObject.containsKey("note")   ){
            item.setNote(jsonObject.get("note").toString());
        }
        if(jsonObject.containsKey("orderStatus")   ){
            item.setOrderStatus(Integer.valueOf(jsonObject.get("orderStatus").toString()));
        }
        if(jsonObject.containsKey("createDate")   ){
            item.setCreateDate(Tools.convertStringToDate(jsonObject.get("createDate").toString(), "yyyy-MM-dd HH:mm:ss"));
        }
        if(jsonObject.containsKey("lastModifyDate")   ){
            item.setLastModifyDate(Tools.convertStringToDate(jsonObject.get("lastModifyDate").toString(), "yyyy-MM-dd HH:mm:ss"));
        }
        if(jsonObject.containsKey("acceptTime")   ){
            item.setAcceptTime(Tools.convertStringToDate(jsonObject.get("acceptTime").toString(), "yyyy-MM-dd HH:mm:ss"));
        }
             tValueAddServiceOrderService.create(item);
             lists.add(tValueAddServiceOrderService.get(Integer.valueOf(id)));

             });
        return lists;
     }

    @ApiOperation(value = "批量删除'TValueAddServiceOrder'表中一条信息", notes = "通过post方法请求，传入表中字段的对应信息，创建一条数据。并返回给View层")
        @RequestMapping(value = "/t_value_add_service_orders/delete/batch",
                method = RequestMethod.POST,
                produces = "application/json;charset=UTF-8")
        @ResponseBody
        public Object deletesTValueAddServiceOrder(
                HttpServletRequest request,
                @RequestHeader(value = "X-Auth-Token", required = false) String token,
                @RequestParam(value = "ids", required = true) String ids
        ) {

            JSONArray jsonArray = JSON.parseArray(ids);
            jsonArray.stream().forEach(id->{

                 TValueAddServiceOrder item = tValueAddServiceOrderService.get(Integer.valueOf(id.toString()));
                if (null != item) {
                    tValueAddServiceOrderService.delete(Integer.valueOf(id.toString()));
                }

            });
            return Resp.succ("delete success");
        }
}
