package com.haomostudio.so.controller;

import com.haomostudio.so.common.Resp;
import com.haomostudio.so.po.TWeixinPayRefundReq;
import com.haomostudio.so.service.TWeixinPayRefundReqService;
import com.haomostudio.so.service.HmUtils.Tools;
import com.alibaba.fastjson.*;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.lang.reflect.InvocationTargetException;
import java.text.SimpleDateFormat;
import java.util.*;

/**
 * Created by hxg on 2016/10/06.
 */
@Api(description = "TWeixinPayRefundReq")
@Controller
public class TWeixinPayRefundReqController {

    @Autowired
    TWeixinPayRefundReqService tWeixinPayRefundReqService;

    @Autowired
    HttpServletResponse response;

    @ApiOperation(value = "创建'TWeixinPayRefundReq'表中一条信息", notes = "通过post方法请求，传入表中字段的对应信息，创建一条数据。并返回给View层")
    @RequestMapping(value = "/t_weixin_pay_refund_reqs/new",
                    method = RequestMethod.POST,
                    produces = "application/json;charset=UTF-8")
    @ResponseBody
    public Object createTWeixinPayRefundReq(
            HttpServletRequest request,
            @RequestHeader(value = "X-Auth-Token") String token,
            @RequestParam(value = "appId", required = false) String appId,
            @RequestParam(value = "mchId", required = false) String mchId,
            @RequestParam(value = "transactionId", required = false) String transactionId,
            @RequestParam(value = "outTradeNo", required = false) String outTradeNo,
            @RequestParam(value = "outRefundNo", required = false) String outRefundNo,
            @RequestParam(value = "totalFee", required = false) Integer totalFee,
            @RequestParam(value = "refundFee", required = false) Integer refundFee,
            @RequestParam(value = "refundDesc", required = false) String refundDesc,
            @RequestParam(value = "requestXml", required = false) String requestXml,
            @RequestParam(value = "weixinPayUnifiedOrderReqId", required = false) Integer weixinPayUnifiedOrderReqId,
            @RequestParam(value = "created", required = false) String created,
            @RequestParam(value = "updated", required = false) String updated
    ) {
        TWeixinPayRefundReq item = new TWeixinPayRefundReq();
        String id = Tools.getUUID();
        item.setId(Integer.valueOf(id));
        if( appId != null ){
            item.setAppId(appId);
        }
        if( mchId != null ){
            item.setMchId(mchId);
        }
        if( transactionId != null ){
            item.setTransactionId(transactionId);
        }
        if( outTradeNo != null ){
            item.setOutTradeNo(outTradeNo);
        }
        if( outRefundNo != null ){
            item.setOutRefundNo(outRefundNo);
        }
        if( totalFee != null ){
            item.setTotalFee(totalFee);
        }
        if( refundFee != null ){
            item.setRefundFee(refundFee);
        }
        if( refundDesc != null ){
            item.setRefundDesc(refundDesc);
        }
        if( requestXml != null ){
            item.setRequestXml(requestXml);
        }
        if( weixinPayUnifiedOrderReqId != null ){
            item.setWeixinPayUnifiedOrderReqId(weixinPayUnifiedOrderReqId);
        }
        if( created != null ){
            item.setCreated(Tools.convertStringToDate(created, "yyyy-MM-dd HH:mm:ss"));
        }
        if( updated != null ){
            item.setUpdated(Tools.convertStringToDate(updated, "yyyy-MM-dd HH:mm:ss"));
        }
        tWeixinPayRefundReqService.create(item);

        //若request param为null，但字段定义有默认值，则需从数据库中返回结果
        return tWeixinPayRefundReqService.get(Integer.valueOf(id));
        //return item;
    }

    @ApiOperation(value = "删除'TWeixinPayRefundReq'表中的某条记录", notes = "根据url传入的数据id，删除整条记录。")
    @RequestMapping(value = "/t_weixin_pay_refund_reqs/{t_weixin_pay_refund_req_id}/delete",
                    method = RequestMethod.POST,
                    produces = "application/json;charset=UTF-8")
    @ResponseBody
    public Object deleteTWeixinPayRefundReq(
            @RequestHeader(value = "X-Auth-Token") String token,
            @PathVariable(value = "t_weixin_pay_refund_req_id") Integer id
    ) {
        TWeixinPayRefundReq item = tWeixinPayRefundReqService.get(id);
        if (null == item) {
            response.setStatus(404);
            return Resp.fail("the asset to be deleted doesn't exist");
        }

        tWeixinPayRefundReqService.delete(id);
        return Resp.succ("delete success");
    }

    @ApiOperation(value = "修改'TWeixinPayRefundReq'表中的某条记录", notes = "根据url传入的数据id，确定修改表中的某条记录，传入表中字段要修改的信息，不传代表不修改。并返回给View层")
    @RequestMapping(value = "/t_weixin_pay_refund_reqs/{t_weixin_pay_refund_req_id}/edit",
                    method = RequestMethod.POST,
                    produces = "application/json;charset=UTF-8")
    @ResponseBody
    public Object editTWeixinPayRefundReq(
            HttpServletRequest request,
            @RequestHeader(value = "X-Auth-Token") String token,
            @PathVariable(value = "t_weixin_pay_refund_req_id") Integer id,
            @RequestParam(value = "appId", required = false) String appId,
            @RequestParam(value = "mchId", required = false) String mchId,
            @RequestParam(value = "transactionId", required = false) String transactionId,
            @RequestParam(value = "outTradeNo", required = false) String outTradeNo,
            @RequestParam(value = "outRefundNo", required = false) String outRefundNo,
            @RequestParam(value = "totalFee", required = false) Integer totalFee,
            @RequestParam(value = "refundFee", required = false) Integer refundFee,
            @RequestParam(value = "refundDesc", required = false) String refundDesc,
            @RequestParam(value = "requestXml", required = false) String requestXml,
            @RequestParam(value = "weixinPayUnifiedOrderReqId", required = false) Integer weixinPayUnifiedOrderReqId,
            @RequestParam(value = "created", required = false) String created,
            @RequestParam(value = "updated", required = false) String updated
    ) {
        TWeixinPayRefundReq item = tWeixinPayRefundReqService.get(id);
        if (null == item) {
            response.setStatus(404);
            return Resp.fail("the asset to be edited doesn't exist");
        }

        if( appId != null ){
            item.setAppId(appId);
        }
        if( mchId != null ){
            item.setMchId(mchId);
        }
        if( transactionId != null ){
            item.setTransactionId(transactionId);
        }
        if( outTradeNo != null ){
            item.setOutTradeNo(outTradeNo);
        }
        if( outRefundNo != null ){
            item.setOutRefundNo(outRefundNo);
        }
        if( totalFee != null ){
            item.setTotalFee(totalFee);
        }
        if( refundFee != null ){
            item.setRefundFee(refundFee);
        }
        if( refundDesc != null ){
            item.setRefundDesc(refundDesc);
        }
        if( requestXml != null ){
            item.setRequestXml(requestXml);
        }
        if( weixinPayUnifiedOrderReqId != null ){
            item.setWeixinPayUnifiedOrderReqId(weixinPayUnifiedOrderReqId);
        }
        if( created != null ){
            item.setCreated(Tools.convertStringToDate(created, "yyyy-MM-dd HH:mm:ss"));
        }
        if( updated != null ){
            item.setUpdated(Tools.convertStringToDate(updated, "yyyy-MM-dd HH:mm:ss"));
        }
        tWeixinPayRefundReqService.update(item);

        return tWeixinPayRefundReqService.get(id);
    }

    @ApiOperation(value = "查询'TWeixinPayRefundReq'表中的某条记录", notes = "根据url传入的数据id，查询对应的一条数据。")
    @RequestMapping(value = "/t_weixin_pay_refund_reqs/{t_weixin_pay_refund_req_id}",
                    method = {RequestMethod.GET, RequestMethod.DELETE, RequestMethod.PUT},
                    produces = "application/json;charset=UTF-8")
    @ResponseBody
    public Object getTWeixinPayRefundReq(
            HttpServletRequest request,
            @RequestHeader(value = "X-Auth-Token") String token,
            @PathVariable(value = "t_weixin_pay_refund_req_id") Integer id,
            @RequestParam(value = "appId", required = false) String appId,
            @RequestParam(value = "mchId", required = false) String mchId,
            @RequestParam(value = "transactionId", required = false) String transactionId,
            @RequestParam(value = "outTradeNo", required = false) String outTradeNo,
            @RequestParam(value = "outRefundNo", required = false) String outRefundNo,
            @RequestParam(value = "totalFee", required = false) Integer totalFee,
            @RequestParam(value = "refundFee", required = false) Integer refundFee,
            @RequestParam(value = "refundDesc", required = false) String refundDesc,
            @RequestParam(value = "requestXml", required = false) String requestXml,
            @RequestParam(value = "weixinPayUnifiedOrderReqId", required = false) Integer weixinPayUnifiedOrderReqId,
            @RequestParam(value = "created", required = false) String created,
            @RequestParam(value = "updated", required = false) String updated
    ) {
        if(request.getMethod().equals("GET")){
            TWeixinPayRefundReq item = tWeixinPayRefundReqService.get(id);
            if (null == item) {
                response.setStatus(404);
                return Resp.fail("the asset to be edited doesn't exist");
            }

            return item;
        }
        else if(request.getMethod().equals("PUT")){
            TWeixinPayRefundReq item = tWeixinPayRefundReqService.get(id);
            if (null == item) {
                response.setStatus(404);
                return Resp.fail("the asset to be edited doesn't exist");
            }

            if( appId != null ){
                item.setAppId(appId);
            }
            if( mchId != null ){
                item.setMchId(mchId);
            }
            if( transactionId != null ){
                item.setTransactionId(transactionId);
            }
            if( outTradeNo != null ){
                item.setOutTradeNo(outTradeNo);
            }
            if( outRefundNo != null ){
                item.setOutRefundNo(outRefundNo);
            }
            if( totalFee != null ){
                item.setTotalFee(totalFee);
            }
            if( refundFee != null ){
                item.setRefundFee(refundFee);
            }
            if( refundDesc != null ){
                item.setRefundDesc(refundDesc);
            }
            if( requestXml != null ){
                item.setRequestXml(requestXml);
            }
            if( weixinPayUnifiedOrderReqId != null ){
                item.setWeixinPayUnifiedOrderReqId(weixinPayUnifiedOrderReqId);
            }
            if( created != null ){
                item.setCreated(Tools.convertStringToDate(created, "yyyy-MM-dd HH:mm:ss"));
            }
            if( updated != null ){
                item.setUpdated(Tools.convertStringToDate(updated, "yyyy-MM-dd HH:mm:ss"));
            }
            tWeixinPayRefundReqService.update(item);

            return tWeixinPayRefundReqService.get(id);
        }
        else if(request.getMethod().equals("DELETE")){
            TWeixinPayRefundReq item = tWeixinPayRefundReqService.get(id);
            if (null == item) {
                response.setStatus(404);
                return Resp.fail("the asset to be deleted doesn't exist");
            }

            tWeixinPayRefundReqService.delete(id);
            return Resp.succ("delete success");
        }
        return Resp.fail("Unknown http method");
    }

    @ApiOperation(value = "查询'TWeixinPayRefundReq'表中的多条记录或者新增某条记录", notes = "get传参：根据url传入的filters（过滤条件），查询对应的多条数据。数据数量取决于pageNo和pageSize；数据的先后顺序取决于sortItem，sortOrder；   post请求：新增某条记录，传入表字段对应的值")
    @RequestMapping(value = "/t_weixin_pay_refund_reqs",
                    method = { RequestMethod.GET, RequestMethod.POST },
                    produces = "application/json;charset=UTF-8")
    @ResponseBody
    public Object getTWeixinPayRefundReqs(
            HttpServletRequest request,
            @RequestHeader(value = "X-Auth-Token", required = false) String token,
            @RequestParam(value = "pageNo", required = false) Integer pageNo,
            @RequestParam(value = "pageSize", required = false) Integer pageSize,
            @RequestParam(value = "sortItem", required = false) String sortItem,
            @RequestParam(value = "sortOrder", required = false) String sortOrder,
            @RequestParam(value = "filters", required = false) String filters,
            @RequestParam(value = "includes", required = false) String includes,
            @RequestParam(value = "refers", required = false) String refers,
            @RequestParam(value = "relates", required = false) String relates
    ) {
        if(pageNo == null){
            pageNo = 1;
        }
        if(pageSize == null){
            pageSize = 10;
        }
        if(sortItem == null){
            sortItem = "id";
        }
        if(sortOrder == null){
            sortOrder = "asc";
        }
        if(filters == null){
            filters = "{}";
        }

        Long total = tWeixinPayRefundReqService.countListWithPagingAndFilter(filters);
        response.addHeader("total", String.valueOf(total));

        return tWeixinPayRefundReqService.getListWithPagingAndFilter(
                        pageNo, pageSize, sortItem, sortOrder, filters, includes, refers, relates);

    }

    @ApiOperation(value = "出入字段数组返回对应字段数据", notes = "get传参：根据url传入的filters（过滤条件），查询对应的多条数据。只返回你传进来的字段对应的数据")
    @RequestMapping(value = "/t_weixin_pay_refund_reqs/columns",
                    method = { RequestMethod.GET },
                    produces = "application/json;charset=UTF-8")
    @ResponseBody
    public Object getTWeixinPayRefundReqsId(
            HttpServletRequest request,
            @RequestHeader(value = "X-Auth-Token", required = false) String token,
            @RequestParam(value = "filters", required = true) String filters,
            @RequestParam(value = "columns", required = true) String columns,
            @RequestParam(value = "sortOrder", required = false) String sortOrder,
            @RequestParam(value = "sortItem", required = false) String sortItem,
            @RequestParam(value = "pageNo", required = false) Integer pageNo,
            @RequestParam(value = "pageSize", required = false) Integer pageSize
    ) {
        if(pageNo == null){
            pageNo = 1;
        }
        if(pageSize == null){
            pageSize = 10;
        }
        if(sortOrder==null){
            sortOrder = "asc";
        }
        if(sortItem==null){
            sortItem = "id";
        }
        JSONArray jsonArray = JSON.parseArray(columns);
        List<Map<String,Object>> lists  = new ArrayList<>();
        List<TWeixinPayRefundReq> list = tWeixinPayRefundReqService.getListWithPagingAndFilter(
                pageNo, pageSize, sortItem, sortOrder, filters);

        //反射调取get方法
        Class clz = TWeixinPayRefundReq.class;
        list.stream().forEach(lot->{
            Map<String,Object> map = new HashMap<>();
            for (Object j : jsonArray){
                String s = (String) j;
                s = s.replaceFirst(s.substring(0,1),s.substring(0,1).toUpperCase());
                try {
                    if (clz.getMethod("get"+s).invoke(lot) !=null){
                        map.put((String) j,clz.getMethod("get"+s).invoke(lot));
                    }
                } catch (NoSuchMethodException e) {
                    e.printStackTrace();
                } catch (InvocationTargetException e) {
                    e.printStackTrace();
                } catch (IllegalAccessException e) {
                    e.printStackTrace();
                }
            }
            lists.add(map);
        });

        return lists;
     }



    @ApiOperation(value = "批量创建'TWeixinPayRefundReq'表中一条信息", notes = "通过post方法请求，传入表中字段的对应信息，创建一条数据。并返回给View层")
    @RequestMapping(value = "/t_weixin_pay_refund_reqs/create//batch",
               method = RequestMethod.POST,
               produces = "application/json;charset=UTF-8")
    @ResponseBody
    public Object createsTWeixinPayRefundReqs(
             HttpServletRequest request,
             @RequestHeader(value = "X-Auth-Token", required = false) String token,
             @RequestParam(value = "params", required = false) String params
    ) {

             JSONArray jsonArray = JSON.parseArray(params);
             List<TWeixinPayRefundReq> lists  = new ArrayList<>();

             jsonArray.stream().forEach((Object object) -> {

             JSONObject jsonObject = JSONObject.parseObject(object.toString());

             TWeixinPayRefundReq item = new TWeixinPayRefundReq();
             String id = Tools.getUUID();
                         item.setId(Integer.valueOf(id));
             if(jsonObject.containsKey("appId")   ){
            item.setAppId(jsonObject.get("appId").toString());
        }
        if(jsonObject.containsKey("mchId")   ){
            item.setMchId(jsonObject.get("mchId").toString());
        }
        if(jsonObject.containsKey("transactionId")   ){
            item.setTransactionId(jsonObject.get("transactionId").toString());
        }
        if(jsonObject.containsKey("outTradeNo")   ){
            item.setOutTradeNo(jsonObject.get("outTradeNo").toString());
        }
        if(jsonObject.containsKey("outRefundNo")   ){
            item.setOutRefundNo(jsonObject.get("outRefundNo").toString());
        }
        if(jsonObject.containsKey("totalFee")   ){
            item.setTotalFee(Integer.valueOf(jsonObject.get("totalFee").toString()));
        }
        if(jsonObject.containsKey("refundFee")   ){
            item.setRefundFee(Integer.valueOf(jsonObject.get("refundFee").toString()));
        }
        if(jsonObject.containsKey("refundDesc")   ){
            item.setRefundDesc(jsonObject.get("refundDesc").toString());
        }
        if(jsonObject.containsKey("requestXml")   ){
            item.setRequestXml(jsonObject.get("requestXml").toString());
        }
        if(jsonObject.containsKey("weixinPayUnifiedOrderReqId")   ){
            item.setWeixinPayUnifiedOrderReqId(Integer.valueOf(jsonObject.get("weixinPayUnifiedOrderReqId").toString()));
        }
        if(jsonObject.containsKey("created")   ){
            item.setCreated(Tools.convertStringToDate(jsonObject.get("created").toString(), "yyyy-MM-dd HH:mm:ss"));
        }
        if(jsonObject.containsKey("updated")   ){
            item.setUpdated(Tools.convertStringToDate(jsonObject.get("updated").toString(), "yyyy-MM-dd HH:mm:ss"));
        }
             tWeixinPayRefundReqService.create(item);
             lists.add(tWeixinPayRefundReqService.get(Integer.valueOf(id)));

             });
        return lists;
     }

    @ApiOperation(value = "批量删除'TWeixinPayRefundReq'表中一条信息", notes = "通过post方法请求，传入表中字段的对应信息，创建一条数据。并返回给View层")
        @RequestMapping(value = "/t_weixin_pay_refund_reqs/delete/batch",
                method = RequestMethod.POST,
                produces = "application/json;charset=UTF-8")
        @ResponseBody
        public Object deletesTWeixinPayRefundReq(
                HttpServletRequest request,
                @RequestHeader(value = "X-Auth-Token", required = false) String token,
                @RequestParam(value = "ids", required = true) String ids
        ) {

            JSONArray jsonArray = JSON.parseArray(ids);
            jsonArray.stream().forEach(id->{

                 TWeixinPayRefundReq item = tWeixinPayRefundReqService.get(Integer.valueOf(id.toString()));
                if (null != item) {
                    tWeixinPayRefundReqService.delete(Integer.valueOf(id.toString()));
                }

            });
            return Resp.succ("delete success");
        }
}
